package str.playerwarps;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.block.Block;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.scheduler.BukkitScheduler;

import com.sk89q.worldguard.bukkit.WorldGuardPlugin;

import str.playerwarps.commands.Commands;
import str.playerwarps.commands.gui.GUI;
import str.playerwarps.gui.types.PaginatedGUI;
import str.playerwarps.gui.types.PaginatedGUIAllPages;
import str.playerwarps.gui.types.PaginatedGUICP;
import str.playerwarps.listener.InventoryListener;
import str.playerwarps.listener.PlayerListener;
import str.playerwarps.listener.WarpBlockListener;
import str.playerwarps.listener.WorldListener;
import str.playerwarps.setup.WarpBox;
import str.playerwarps.util.Utils;
import str.playerwarps.util.Zone;

public class PlayerWarps extends JavaPlugin implements Listener {
	
	public static PlayerWarps plugin;
	public static WarpBox wb;
	public static WarpBlockListener wbl;
	public static WorldListener wl;
	public static GUI gui;
	private File dataFile;
	private FileConfiguration data;
	public static List<String> warpsort;
	public boolean featherBoardHook = false;
	private boolean depend1, depend2, depend3 = true;
	public static Location nextLocation = new Location(Bukkit.getWorld("PlayerWarps-World"), -10000, 0, 0);
	
	@Override
	public void onEnable() {
		plugin = this;
		gui = new GUI();
		System.out.println("[PlayerWarps] Loading Config");
		createCustomData();
		System.out.println("[PlayerWarps] Loaded Config");
		System.out.println("[PlayerWarps] Registering Events");
		getServer().getPluginManager().registerEvents(this, this);
		PaginatedGUI.prepare(this);
		PaginatedGUIAllPages.prepare(this);
		PaginatedGUICP.prepare(this);
		if (isFeatherBoardPresent()) {
			setfeatherBoardHook(true);
			Utils.sendConsoleMessage("&a[PlayerWarps] Featherboard support enabled");
		}
		else {
			setfeatherBoardHook(false);
			Utils.sendConsoleMessage("&c[PlayerWarps] Featherboard not found, disabling support");
		}
		if (Bukkit.getServer().getPluginManager().getPlugin("Multiverse-Core") != null) {
			Utils.sendConsoleMessage("&a[PlayerWarps] Dependencies found: Multiverse-Core");
		}
		else {
			Utils.sendConsoleMessage("&c[PlayerWarps] Dependencies not found: Multiverse-Core");
			Utils.sendConsoleMessage("&c[PlayerWarps] Disabling plugin as required dependencies not found!");
			onDisable();
			return;
		}
		if (Bukkit.getServer().getPluginManager().getPlugin("WorldEdit") != null) {
			Utils.sendConsoleMessage("&a[PlayerWarps] Dependencies found: WorldEdit");
		}
		else {
			Utils.sendConsoleMessage("&c[PlayerWarps] Dependencies not found: WorldEdit");
			Utils.sendConsoleMessage("&c[PlayerWarps] Disabling plugin as required dependencies not found!");
			onDisable();
			return;
		}
		if (Bukkit.getServer().getPluginManager().getPlugin("WorldGuard") != null) {
			Utils.sendConsoleMessage("&a[PlayerWarps] Dependencies found: WorldGuard");
		}
		else {
			Utils.sendConsoleMessage("&c[PlayerWarps] Dependencies not found: WorldGuard");
			Utils.sendConsoleMessage("&c[PlayerWarps] Disabling plugin as required dependencies not found!");
			onDisable();
			return;
		}
		if (Bukkit.getServer().getPluginManager().getPlugin("FastAsyncWorldEdit") != null) {
			Utils.sendConsoleMessage("&a[PlayerWarps] Dependencies found: FastAsyncWorldEdit");
		}
		else {
			Utils.sendConsoleMessage("&c[PlayerWarps] Dependencies not found: FastAsyncWorldEdit");
			Utils.sendConsoleMessage("&c[PlayerWarps] Disabling plugin as required dependencies not found!");
			onDisable();
			return;
		}
		Bukkit.getServer().getPluginManager().registerEvents(new WorldListener(), this);
		Bukkit.getServer().getPluginManager().registerEvents(new InventoryListener(), this);
		Bukkit.getServer().getPluginManager().registerEvents(new PlayerListener(), this);
		Bukkit.getServer().getPluginManager().registerEvents(new WarpBlockListener(), this);
		Bukkit.getServer().getPluginManager().registerEvents(new WarpBox(), this);
		System.out.println("[PlayerWarps] Loading Variables");
		wb = new WarpBox();
		wl = new WorldListener();
		System.out.println("[PlayerWarps] Loaded Variables");
		System.out.println("[PlayerWarps] Loaded Events");
		System.out.println("[PlayerWarps] Registering Commands");
		getCommand("warpcreate").setExecutor(new Commands(this));
		getCommand("warpcreateblock").setExecutor(new Commands(this));
		getCommand("pw").setExecutor(new GUI());
//		getCommand("pwgui").setExecutor(new GUI());
		System.out.println("[PlayerWarps] Loaded Commands");
		System.out.println("[PlayerWarps] Loading Cache");
		if (getCustomData().getConfigurationSection("Saved-Blocks") != null) {
			for (String key : getCustomData().getConfigurationSection("Saved-Blocks").getKeys(false)) {
				wbl.placedBlock.add(new Location(Bukkit.getWorld(getCustomData().getString("Saved-Blocks." + key + ".world")), getCustomData().getInt("Saved-Blocks." + key + ".x"), getCustomData().getInt("Saved-Blocks." + key + ".y"), getCustomData().getInt("Saved-Blocks." + key + ".z")));
			}
		}
//		if (getCustomData().getConfigurationSection("Saved-Walls") != null) {
//			for (String key : getCustomData().getConfigurationSection("Saved-Walls").getKeys(false)) {
//				wbl.walls.add(new Location(Bukkit.getWorld(getCustomData().getString("Saved-Walls." + key + ".world")), getCustomData().getInt("Saved-Walls." + key + ".x"), getCustomData().getInt("Saved-Walls." + key + ".y"), getCustomData().getInt("Saved-Walls." + key + ".z")));
//			}
//		}
		warpsort = (List<String>) getCustomData().getStringList("WarpSort");
		if (getCustomData().get("guiRefreshRateInSeconds") == null) {
            getCustomData().set("guiRefreshRateInSeconds", 5);
            saveConfig();
        }
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null && Bukkit.getWorld("PlayerWarps-World") != null) {
			BukkitScheduler scheduler = getServer().getScheduler();
			scheduler.scheduleSyncRepeatingTask(this, new Runnable() {
				@Override
				public void run() {
					warpsort.clear();
	            	Set<String> set = getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
	                for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
	        			UUID uuid = UUID.fromString(it.next());
	        			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString()) != null) {
	        				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
								if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
										if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") == null) {
											continue;
										}
										else {
											int sort = 0;
											Location loc = Utils.getPlayerWarpLocation(Bukkit.getOfflinePlayer(uuid).getUniqueId().toString());
											for (Player players : Bukkit.getWorld("PlayerWarps-World").getPlayers()) {
												if (Zone.contains(players.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
													sort++;
												}
											}
											warpsort.add(sort + " - " + uuid.toString());
										}
									}
								}
							}
	        			}
	        		}
	                Collections.sort(warpsort, Collections.reverseOrder());
	        		if (getCustomData().getStringList("WarpList") == null) {
	        			getCustomData().set("WarpSort", warpsort);
	        			saveConfig();
	        			reloadConfig();
	        		}
	        		else {
	        			getCustomData().set("WarpSort", null);
	        			getCustomData().set("WarpSort", warpsort);
	        			saveConfig();
	        			reloadConfig();
	        		}
				}
	        }, 20l, (long)(20 * getCustomData().getLong("guiRefreshRateInSeconds")));
		}
		loadNextLocation();
		System.out.println("[PlayerWarps] Loaded Cache");
		System.out.println("[PlayerWarps] Loading FilterList");
//		InventoryListener.addFilterList();
		System.out.println("[PlayerWarps] Loaded FilterList");
		System.out.println("[PlayerWarps] Enabled");
	}
	
	public void onDisable() {
		getCustomData().set("nextXLocation", nextLocation.getX());
		saveConfig();
		int i = 0;
		for (Location loc : wbl.placedBlock) {
			i++;
			getCustomData().set("Saved-Blocks." + i + ".x", loc.getX());
			getCustomData().set("Saved-Blocks." + i + ".y", loc.getY());
			getCustomData().set("Saved-Blocks." + i + ".z", loc.getZ());
			getCustomData().set("Saved-Blocks." + i + ".world", loc.getWorld().getName());
		}
		saveConfig();
		
		System.out.println("[PlayerWarps] Disabled");
	}

	public boolean getFeatherboardSupport() {
		return featherBoardHook;
	}
	
	public void loadNextLocation() {
		if (getCustomData().contains("nextXLocation")) {
			double x = getCustomData().getDouble("nextXLocation");
			nextLocation = new Location(Bukkit.getWorld("PlayerWarps-World"), x, 0, 0);
		}
		else {
			getCustomData().set("nextXLocation", nextLocation.getX());
			saveConfig();
		}
	}
	
	public FileConfiguration getCustomData() {
    	return this.data;
    }
	
	private void createCustomData() {
    	dataFile = new File(getDataFolder(), "data.yml");
    	if (!dataFile.exists()) {
    		dataFile.getParentFile().mkdirs();
    		saveResource("data.yml", false);
    	}
    	
    	data = new YamlConfiguration();
    	try {
    		data.load(dataFile);
    	} catch (IOException | InvalidConfigurationException e) {
    		e.printStackTrace();
    	}
    }
	
	public static PlayerWarps get() {
		return plugin;
	}
	
	public static WarpBox getWarpBox() {
		return wb;
	}
	
	public static WorldListener getWorldSetup() {
		return wl;
	}

	public static WarpBlockListener getWarpBlock() {
		return wbl;
	}
	
	public void saveConfig() {
        try {
            this.data.save(this.dataFile);
        } catch (IOException e) {
        	getLogger().warning("Unable to save data.yml");
        }
    }
 
    public void reloadConfig() {
        this.data = YamlConfiguration.loadConfiguration(this.dataFile);
    }

    private boolean isFeatherBoardPresent() {
		if (getServer().getPluginManager().getPlugin("FeatherBoard") == null) {
			setfeatherBoardHook(false);
			return featherBoardHook;
		}
		if (getServer().getPluginManager().getPlugin("FeatherBoard").isEnabled()) {
			setfeatherBoardHook(true);
		}

		return featherBoardHook;
	}

	private void setfeatherBoardHook(boolean a) {
		featherBoardHook = a;
	}
}
