package str.playerwarps.gui.buttons;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;

import str.playerwarps.PlayerWarps;
import str.playerwarps.gui.types.PaginatedGUI;
import str.playerwarps.gui.types.PaginatedGUIAllPages;
import str.playerwarps.gui.types.PaginatedGUICP;

public class InventoryListenerGUIAllPages implements Listener {

    @EventHandler
    public void onInventoryClick(InventoryClickEvent event) {
        // Determine if the Inventory was a PaginatedGUI
        if (event.getInventory().getHolder() != null
                && event.getInventory().getHolder() instanceof PaginatedGUIAllPages) {

            // Get the instance of the PaginatedGUI that was clicked.
        	PaginatedGUIAllPages paginatedGUI = (PaginatedGUIAllPages) event.getInventory().getHolder();

            // Then, assume the slot holds a GUIButton and attempt to get the button.
            GUIButton button = paginatedGUI.getButton(event.getSlot());

            // Finally, if the slot did actually hold a GUIButton (that has a listener)...
            if (button != null && button.getListener() != null) {
                // ...execute that button's listener.
                button.getListener().onClick(event);
            }

        }
    }
    
    @EventHandler
    public void onInventoryClose(InventoryCloseEvent event) {
        // Determine if the Inventory was a PaginatedGUI.
        if (event.getInventory().getHolder() != null
                && event.getInventory().getHolder() instanceof PaginatedGUIAllPages) {
        	
			// Set the instance of the Player who closed the PaginatedGUI. 
			Player player = (Player) event.getPlayer();
			
			// Get the instance of the PaginatedGUI that was closed.
			PaginatedGUIAllPages inventory = (PaginatedGUIAllPages) event.getInventory().getHolder();
			
			// Then, assume the inventory did actually have a listener.
			if (inventory != null && inventory.getCloseListener() != null) {
				// Finally, if the PaginatedGUI was a sub-menu...
				if (PaginatedGUI.inSubMenu.get(player) == true) {
					// ...execute that inventory's listener.
					inventory.getCloseListener().onClose(event);
				}
			}
        }
    }
}
