package str.playerwarps.listener;

import static com.sk89q.worldguard.bukkit.BukkitUtil.toVector;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.UUID;

import org.apache.commons.lang.StringUtils;
import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.OfflinePlayer;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.command.PluginCommand;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Arrow;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;
import org.bukkit.event.entity.ProjectileLaunchEvent;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.player.PlayerChangedWorldEvent;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.player.PlayerTeleportEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.plugin.Plugin;
import org.bukkit.util.Vector;

import com.sk89q.worldedit.event.Event;
import com.sk89q.worldguard.bukkit.WorldGuardPlugin;
import com.sk89q.worldguard.protection.ApplicableRegionSet;
import com.sk89q.worldguard.protection.managers.RegionManager;
import com.sk89q.worldguard.protection.regions.ProtectedRegion;

import str.playerwarps.PlayerWarps;
import str.playerwarps.gui.ItemBuilder;
import str.playerwarps.gui.buttons.GUIButton;
import str.playerwarps.gui.types.PaginatedGUI;
import str.playerwarps.gui.types.PaginatedGUIAllPages;
import str.playerwarps.gui.types.PaginatedGUICP;
import str.playerwarps.util.ItemMetadata;
import str.playerwarps.util.Utils;
import str.playerwarps.util.Zone;
import str.playerwarps.util.ZoneVector;

public class PlayerListener implements Listener {
	
	public List<String> filterList = PlayerWarps.get().getCustomData().getStringList("Blocked-Warp-Wall-Items");
	
	public static boolean isWithinRegion(Player player, String region)
    { 
		return isWithinRegion(player.getLocation(), region);
    }

	public static boolean isWithinRegion(Block block, String region)
    { 
		return isWithinRegion(block.getLocation(), region); 
		}

	public static boolean isWithinRegion(Location loc, String region)
	{
		WorldGuardPlugin guard = getWorldGuard();
		com.sk89q.worldedit.Vector v = toVector(loc);
		RegionManager manager = guard.getRegionManager(loc.getWorld());
		ApplicableRegionSet set = manager.getApplicableRegions(v);
		for (ProtectedRegion each : set) {
			if (each.getId().equalsIgnoreCase(region)) {
				return true;
			}
		}
		return false;
	}
	
	private static WorldGuardPlugin getWorldGuard() {
	    Plugin plugin = Bukkit.getServer().getPluginManager().getPlugin("WorldGuard");
	 
	    // WorldGuard may not be loaded
	    if (plugin == null || !(plugin instanceof WorldGuardPlugin)) {
	        System.out.println("Error: WorldGuard not installed!");
	        return null; // Maybe you want throw an exception instead
	    }
	 
	    return (WorldGuardPlugin) plugin;
	}
	
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onJoin(PlayerJoinEvent event) {
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + event.getPlayer().getUniqueId().toString()) != null) {
				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + event.getPlayer().getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + event.getPlayer().getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
					World w = Bukkit.getWorld("PlayerWarps-World");
					Location loc = w.getSpawnLocation();
					Utils.removeWarpBuilding(event.getPlayer().getUniqueId().toString());
					event.getPlayer().setGameMode(GameMode.SURVIVAL);
					event.getPlayer().getInventory().clear();
					event.getPlayer().getInventory().clear();
					event.getPlayer().getOpenInventory().getBottomInventory().clear();
					event.getPlayer().getOpenInventory().getTopInventory().clear();
				}
			}
		}
	}
	
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onLeave(PlayerQuitEvent event) {
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + event.getPlayer().getUniqueId().toString()) != null) {
				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + event.getPlayer().getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + event.getPlayer().getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
					World w = Bukkit.getWorld("PlayerWarps-World");
					Location loc = w.getSpawnLocation();
					Utils.removeWarpBuilding(event.getPlayer().getUniqueId().toString());
					event.getPlayer().setGameMode(GameMode.SURVIVAL);
					event.getPlayer().getInventory().clear();
					event.getPlayer().getInventory().clear();
					event.getPlayer().getOpenInventory().getBottomInventory().clear();
					event.getPlayer().getOpenInventory().getTopInventory().clear();
				}
			}
		}
	}
	
	@EventHandler
	public void onJoin2(PlayerJoinEvent event) {
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + event.getPlayer().getUniqueId().toString()) != null) {
				Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
				for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
					UUID uuid = UUID.fromString(it.next());
					OfflinePlayer player = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid);
					if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString()) != null) {
						if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
							Location loc;
							Location loc2;
							for (Player players : Bukkit.getWorld("PlayerWarps-World").getPlayers()) {
	//							if (event.getPlayer().getWorld().getName().equals("PlayerWarps-World")) {
	//								event.getPlayer().teleport(Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world")).getSpawnLocation());
	//							}
								if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + uuid.toString()) != null) {
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".xb") != null) {
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".yb") != null) {
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".zb") != null) {
												if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".worldnameb") != null) {
													loc = Utils.getPlayerWarpLocation(player.getUniqueId().toString());
													if (players.getUniqueId() != player.getUniqueId()) {
	//													if (Zone.contains(event.getPlayer().getLocation(), loc2.getBlockX(), loc2.getBlockX() - 89, loc2.getBlockZ() - 7, loc2.getBlockZ() + 65)) {
	//														event.getPlayer().teleport(Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world")).getSpawnLocation());
	//													}
	//													if (Zone.contains(event.getPlayer().getLocation(), 72, 24, 0, loc2.getBlockZ() + 49)) {
	//														event.getPlayer().teleport(Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world")).getSpawnLocation());
	//													}
														if (Zone.contains(event.getPlayer().getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
															event.getPlayer().teleport(Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world")).getSpawnLocation());
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onDamage(EntityDamageEvent event) {
		if (event.getEntity() instanceof Player) {
			Player player = (Player) event.getEntity();
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
				if (PlayerWarps.get().getCustomData().contains("Warps-Created-By." + player.getUniqueId().toString())) {
					if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
						if (event.getCause() == DamageCause.FALL) {
							event.setCancelled(true);
						}
						else if (event.getCause() == DamageCause.VOID) {
							event.setCancelled(true);
							Location loc = Utils.getPlayerWarpLocation(player.getUniqueId().toString());
							player.teleport(loc);
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onCommand(PlayerCommandPreprocessEvent event) {
		Player p = event.getPlayer();
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + event.getPlayer().getUniqueId().toString()) != null) {
			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null) {
				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
					String plname = PlayerWarps.get().getDescription().getName().toLowerCase();
	//				String cmd = event.getMessage().split(" ")[0].toLowerCase();
					String cm = "";
					for (int i = 0; i < event.getMessage().split(" ").length; i++) {
						String arg = (event.getMessage().split(" ")[i] + " ");
						cm += arg;
					}
					String cmd = StringUtils.chop(cm);
					
					if (cmd.isEmpty())
					{
						return;
					}
					cmd = cmd.substring(1);
					if (cmd.startsWith(plname + ":"))
					{
						cmd = cmd.substring(plname.length() + 1);
					}
					PluginCommand command = PlayerWarps.get().getCommand("warpcreate");
	
					boolean match = command.getName().equalsIgnoreCase(cmd);
					
					List<String> commands = (List<String>) PlayerWarps.get().getCustomData().getStringList("command-whitelist");
	
					if (!match)
					{
						for (String a : command.getAliases())
						{
							if (cmd.equalsIgnoreCase(a))
							{
								match = true;
								break;
							}
						}
						
						for (int i = 0; i < commands.size(); i++) {
							String c = commands.get(i);
							if (cmd.equalsIgnoreCase(c) || cmd.startsWith(c)) {
								match = true;
								break;
							}
						}
					}
	
					if (!match)
					{
						event.setCancelled(true);
						Utils.sendMessage(event.getPlayer(), "&cYou're cannot use this command while creating a playerwarp.");
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onInteract(PlayerInteractEvent event) {
		Player p = (Player) event.getPlayer();
		if (event.getClickedBlock() == null) return;
		if (event.getClickedBlock().getType() == Material.CHEST || event.getClickedBlock().getType() == Material.ENDER_CHEST || event.getClickedBlock().getType() == Material.TRAPPED_CHEST) {
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
					event.setCancelled(true);
					Utils.sendMessage(p, "&cYou cannot open containers inside of a playerwarp.");
				}
			}
		}
		if (event.getClickedBlock().getType() == Material.BEACON) {
			event.setCancelled(true);
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
				if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
					if (Utils.getPlayerWarpLocation(p.getUniqueId().toString()) != null) {
						Location loc = Utils.getPlayerWarpLocation(p.getUniqueId().toString());
						if (Zone.contains(p.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
								if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("false")) {
									PaginatedGUICP controlPanel = new PaginatedGUICP("Warp Create: Control Panel");
									GUIButton glassPane = new GUIButton(ItemBuilder.start(Material.STAINED_GLASS_PANE).data((short)15).name(" ").build());
									glassPane.setListener(event1 -> {
										event1.setCancelled(true);
									});
									for (int i = 0; i < 10; i++) {
										controlPanel.setButton(i, glassPane);
									}
									List<String> infoLore = new ArrayList<String>();
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Need-Approval") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Need-Approval").equalsIgnoreCase("false")) {
										infoLore.add("&7Status: &aApproved");
									}
									else {
										infoLore.add("&7Status: &cUnapproved");
									}
									if (Utils.getEditTime(p.getUniqueId().toString()) != 0) {
										infoLore.add("&7Banked Edit Time: &f" + Utils.formatSeconds(Long.valueOf(Utils.getEditTime(p.getUniqueId().toString()))));
									}
									else {
										infoLore.add("&7Banked Edit Time: &f" + Utils.getEditTime(p.getUniqueId().toString()) + "s");
									}
									GUIButton info = new GUIButton(ItemBuilder.start(Material.PAPER).name("&a&lInformation").lore(infoLore).build());
									info.setListener(event2 -> {
										event2.setCancelled(true);
									});
									controlPanel.addButton(info);
									for (int i = 11; i < 15; i++) {
										controlPanel.setButton(i, glassPane);
									}
									List<String> transactionsLore = new ArrayList<String>();
									transactionsLore.add("&7The last 10 time transactions of your warp,");
									transactionsLore.add("&7this is sorted latest to oldest.");
									if (Utils.getTransactions(p.getUniqueId().toString()) != false) {
										transactionsLore.add("");
										List<String> t = (List<String>) PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + p.getUniqueId().toString());
										int count = 1;
										for (int i = 0; i < PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + p.getUniqueId().toString()).size(); i++) {
											transactionsLore.add("&e&l" + count + ") " + PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + p.getUniqueId().toString()).get(i));
											count++;
										}
									}
									GUIButton transactions = new GUIButton(ItemBuilder.start(Material.EMPTY_MAP).name("&a&lTransactions").lore(transactionsLore).build());
									transactions.setListener(event3 -> {
										event3.setCancelled(true);
									});
									controlPanel.addButton(transactions);
									List<String> editWarpLore = new ArrayList<String>();
									if (Utils.getEditTime(p.getUniqueId().toString()) == 0) {
										editWarpLore.add("");
										editWarpLore.add("&7You currently cannot start editing your warp");
										editWarpLore.add("&7as you have no edit time available.");
										editWarpLore.add("");
										editWarpLore.add("&c[You must have remaining time to edit your warp]");
									}
									else {
										editWarpLore.add("");
										editWarpLore.add("&7This will allow you to enter edit mode on your warp.");
										editWarpLore.add("&7Time Remaining: &f" + Utils.formatSeconds(Long.valueOf(Utils.getEditTime(p.getUniqueId().toString()))));
										editWarpLore.add("");
										editWarpLore.add("&a[Click to start editing your warp]");
									}
									GUIButton editWarp = new GUIButton(ItemBuilder.start(Material.BOOK_AND_QUILL).name("&a&lEdit Warp").lore(editWarpLore).build());
									editWarp.setListener(event4 -> {
										event4.setCancelled(true);
										if (event4.getRawSlot() < event4.getInventory().getSize()) {
											if (Utils.getEditTime(p.getUniqueId().toString()) != 0) {
												if (p.getOpenInventory() != null) p.closeInventory();
												p.getInventory().clear();
												PlayerWarps.get().getWorldSetup().createVoidWorld(p, true, Utils.getEditTime(p.getUniqueId().toString()));
											}
										}
									});
									controlPanel.addButton(editWarp);
									for (int i = 17; i < 27; i++) {
										controlPanel.setButton(i, glassPane);
									}
									p.openInventory(controlPanel.getInventory());
								}
								else {
									PaginatedGUICP controlPanel = new PaginatedGUICP("Warp Create: Control Panel");
									GUIButton glassPane = new GUIButton(ItemBuilder.start(Material.STAINED_GLASS_PANE).data((short)15).name(" ").build());
									glassPane.setListener(event1 -> {
										event1.setCancelled(true);
									});
									for (int i = 0; i < 10; i++) {
										controlPanel.setButton(i, glassPane);
									}
									List<String> infoLore = new ArrayList<String>();
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Need-Approval") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Need-Approval").equalsIgnoreCase("false")) {
										infoLore.add("&7Status: &aApproved");
									}
									else {
										infoLore.add("&7Status: &cUnapproved");
									}
									if (Utils.getEditTime(p.getUniqueId().toString()) != 0) {
										infoLore.add("&7Banked Edit Time: &f" + Utils.formatSeconds(Long.valueOf(Utils.getEditTime(p.getUniqueId().toString()))));
									}
									else {
										infoLore.add("&7Banked Edit Time: &f" + Utils.getEditTime(p.getUniqueId().toString()) + "s");
									}
									GUIButton info = new GUIButton(ItemBuilder.start(Material.PAPER).name("&a&lInformation").lore(infoLore).build());
									info.setListener(event2 -> {
										event2.setCancelled(true);
									});
									controlPanel.addButton(info);
									controlPanel.addButton(glassPane);

									List<String> spawnRoomWallsLore = new ArrayList<String>();
									spawnRoomWallsLore.add("&7Change what the wall material composition");
									spawnRoomWallsLore.add("&7of your warp are made out of.");
									spawnRoomWallsLore.add("");
									spawnRoomWallsLore.add("&a[Left click to edit Spawn Room walls]");
									GUIButton editSpawnRoomWalls = new GUIButton(ItemBuilder.start(Material.BRICK).name("&e&lEdit Spawn Room Walls").lore(spawnRoomWallsLore).build());
									editSpawnRoomWalls.setListener(event4 -> {
										event4.setCancelled(true);
										if (event4.getRawSlot() < event4.getInventory().getSize()) {
											PaginatedGUIAllPages controlPanelSR = new PaginatedGUIAllPages("Warp Create Walls: Spawn Room");
											PaginatedGUI.inSubMenu.put(p, true);
											for (int i = 0; i < 4; i++) {
												controlPanelSR.setButton(i, glassPane);
											}
											GUIButton paper = new GUIButton(ItemBuilder.start(Material.PAPER).build());
											paper.setListener(e -> {
												e.setCancelled(true);
											});
											controlPanelSR.addButton(paper);
											for (int i = 0; i < 19; i++) {
												controlPanelSR.setButton(i, glassPane);
											}
											List<String> blockLore = new ArrayList<String>();
											blockLore.add("&7Click another block in your inventory");
											blockLore.add("&7to change the composition.");
											blockLore.add("");
											blockLore.add("&c[Click to remove first block and move down one]");
											GUIButton glass = new GUIButton(ItemBuilder.start(Material.GLASS).lore(blockLore).build());
											glass.setListener(e2 -> {
												e2.setCancelled(true);
											});
											controlPanelSR.addButton(glass);
											for (int i = 26; i < 36; i++) {
												controlPanelSR.setButton(i, glassPane);
											}
											controlPanelSR.setCloseListener(e1 -> {
												Bukkit.getScheduler().runTaskLater(PlayerWarps.get(), new Runnable() {
							    					public void run() {
							    						ItemStack block1 = controlPanelSR.getButton(19).getItem();
							    						ItemStack[] blocks = new ItemStack[]{block1};
							    						ItemMeta meta = block1.getItemMeta();
							    						meta.setLore(null);
							    						block1.setItemMeta(meta);
							    						ItemStack block2;
							    						if (controlPanelSR.getButton(20) != null) {
							    							block2 = controlPanelSR.getButton(20).getItem();
							    							ItemMeta meta1 = block2.getItemMeta();
								    						meta1.setLore(null);
								    						block2.setItemMeta(meta1);
								    						blocks = new ItemStack[]{block1, block2};
								    						ItemStack block3;
								    						if (controlPanelSR.getButton(21) != null) {
								    							block3 = controlPanelSR.getButton(21).getItem();
								    							ItemMeta meta2 = block3.getItemMeta();
									    						meta2.setLore(null);
									    						block3.setItemMeta(meta2);
									    						blocks = new ItemStack[]{block1, block2, block3};
									    						ItemStack block4;
									    						if (controlPanelSR.getButton(22) != null) {
									    							block4 = controlPanelSR.getButton(22).getItem();
									    							ItemMeta meta3 = block4.getItemMeta();
									    							meta3.setLore(null);
									    							block4.setItemMeta(meta3);
									    							blocks = new ItemStack[]{block1, block2, block3, block4};
									    							ItemStack block5;
									    							if (controlPanelSR.getButton(23) != null) {
									    								block5 = controlPanelSR.getButton(23).getItem();
									    								ItemMeta meta4 = block5.getItemMeta();
									    								meta4.setLore(null);
									    								block5.setItemMeta(meta4);
									    								blocks = new ItemStack[]{block1, block2, block3, block4, block5};
									    								ItemStack block6;
									    								if (controlPanelSR.getButton(24) != null) {
									    									block6 = controlPanelSR.getButton(24).getItem();
									    									ItemMeta meta5 = block6.getItemMeta();
									    									meta5.setLore(null);
									    									block6.setItemMeta(meta5);
									    									blocks = new ItemStack[]{block1, block2, block3, block4, block5, block6};
									    									ItemStack block7;
									    									if (controlPanelSR.getButton(25) != null) {
									    										block7 = controlPanelSR.getButton(25).getItem();
									    										ItemMeta meta6 = block7.getItemMeta();
									    										meta6.setLore(null);
									    										block7.setItemMeta(meta6);
									    										blocks = new ItemStack[]{block1, block2, block3, block4, block5, block6, block7};
									    									}
									    								}
									    							}
									    						}
								    						}
							    						}
//							    						ItemStack block = controlPanelWR.getButton(22).getItem();
//							    						Utils.saveWallData(p.getUniqueId().toString(), block, false);
							    						PlayerWarps.getWarpBox().generateCubee(loc.clone().subtract(24.500, 15.00000, -2.500), new int[]{}, new int[]{9, 8, 7}, new int[]{7, 6, 0}, new int[]{}, new int[]{7, 1, 6}, blocks, Material.GLOWSTONE, Material.AIR, Material.GRASS, Material.STONE, Material.BEACON);
							    						if (PaginatedGUI.inSubMenu.get(p) == true) {
							    							PaginatedGUI.inSubMenu.remove(p);
							    						}
							    						if (p.getOpenInventory() != null) p.closeInventory();
							    						p.openInventory(controlPanel.getInventory());
							    						Utils.sendMessage(p, "&e&lWarp Create &aSpawn room walls have been updated!");
							    					}
							    				}, 1L);
											});
											if (p.getOpenInventory() != null) p.closeInventory();
											p.openInventory(controlPanelSR.getInventory());
										}
									});
									
									controlPanel.addButton(editSpawnRoomWalls);
									controlPanel.addButton(glassPane);
									List<String> warpRoomWallsLore = new ArrayList<String>();
									warpRoomWallsLore.add("&7Change what the wall material composition");
									warpRoomWallsLore.add("&7of your warp are made out of.");
									warpRoomWallsLore.add("");
									warpRoomWallsLore.add("&a[Left click to edit Warp Room walls]");
									GUIButton editWarpRoomWalls = new GUIButton(ItemBuilder.start(Material.BRICK).name("&e&lEdit Warp Room Walls").lore(warpRoomWallsLore).build());
									editWarpRoomWalls.setListener(event4 -> {
										event4.setCancelled(true);
										if (event4.getRawSlot() < event4.getInventory().getSize()) {
											PaginatedGUIAllPages controlPanelWR = new PaginatedGUIAllPages("Warp Create Walls: Warp Room");
											PaginatedGUI.inSubMenu.put(p, true);
											for (int i = 0; i < 4; i++) {
												controlPanelWR.setButton(i, glassPane);
											}
											GUIButton paper = new GUIButton(ItemBuilder.start(Material.PAPER).build());
											paper.setListener(e -> {
												e.setCancelled(true);
											});
											controlPanelWR.addButton(paper);
											for (int i = 0; i < 19; i++) {
												controlPanelWR.setButton(i, glassPane);
											}
											List<String> blockLore = new ArrayList<String>();
											blockLore.add("&7Click another block in your inventory");
											blockLore.add("&7to change the composition.");
											blockLore.add("");
											blockLore.add("&c[Click to remove first block and move down one]");
											GUIButton glass = new GUIButton(ItemBuilder.start(Material.GLASS).lore(blockLore).build());
											glass.setListener(e2 -> {
												e2.setCancelled(true);
												if (controlPanelWR.getButton(20) != null) {
													controlPanelWR.removeButton(19);
													GUIButton item1 = controlPanelWR.getButton(20);
													controlPanelWR.removeButton(20);
													controlPanelWR.setButton(19, item1);
													if (controlPanelWR.getButton(21) != null) {
														GUIButton item2 = controlPanelWR.getButton(21);
														controlPanelWR.removeButton(21);
														controlPanelWR.setButton(20, item2);
														if (controlPanelWR.getButton(22) != null) {
															GUIButton item3 = controlPanelWR.getButton(22);
															controlPanelWR.removeButton(22);
															controlPanelWR.setButton(21, item3);
															if (controlPanelWR.getButton(23) != null) {
																GUIButton item4 = controlPanelWR.getButton(23);
																controlPanelWR.removeButton(23);
																controlPanelWR.setButton(22, item4);
																if (controlPanelWR.getButton(24) != null) {
																	GUIButton item5 = controlPanelWR.getButton(24);
																	controlPanelWR.removeButton(24);
																	controlPanelWR.setButton(23, item5);
																	if (controlPanelWR.getButton(25) != null) {
																		GUIButton item6 = controlPanelWR.getButton(25);
																		controlPanelWR.removeButton(25);
																		controlPanelWR.setButton(24, item6);
																	}
																}
															}
														}
													}
												}
												else {
													Utils.sendMessage(p, "&cYou cannot remove this as there has to be at least 1 block selected.");
												}
											});
											controlPanelWR.addButton(glass);
											for (int i = 26; i < 36; i++) {
												controlPanelWR.setButton(i, glassPane);
											}
											controlPanelWR.setCloseListener(e1 -> {
												Bukkit.getScheduler().runTaskLater(PlayerWarps.get(), new Runnable() {
							    					public void run() {
							    						ItemStack block1 = controlPanelWR.getButton(19).getItem();
							    						ItemStack[] blocks = new ItemStack[]{block1};
							    						ItemMeta meta = block1.getItemMeta();
							    						meta.setLore(null);
							    						block1.setItemMeta(meta);
							    						ItemStack block2;
							    						if (controlPanelWR.getButton(20) != null) {
							    							block2 = controlPanelWR.getButton(20).getItem();
							    							ItemMeta meta1 = block2.getItemMeta();
								    						meta1.setLore(null);
								    						block2.setItemMeta(meta1);
								    						blocks = new ItemStack[]{block1, block2};
								    						ItemStack block3;
								    						if (controlPanelWR.getButton(21) != null) {
								    							block3 = controlPanelWR.getButton(21).getItem();
								    							ItemMeta meta2 = block3.getItemMeta();
									    						meta2.setLore(null);
									    						block3.setItemMeta(meta2);
									    						blocks = new ItemStack[]{block1, block2, block3};
									    						ItemStack block4;
									    						if (controlPanelWR.getButton(22) != null) {
									    							block4 = controlPanelWR.getButton(22).getItem();
									    							ItemMeta meta3 = block4.getItemMeta();
									    							meta3.setLore(null);
									    							block4.setItemMeta(meta3);
									    							blocks = new ItemStack[]{block1, block2, block3, block4};
									    							ItemStack block5;
									    							if (controlPanelWR.getButton(23) != null) {
									    								block5 = controlPanelWR.getButton(23).getItem();
									    								ItemMeta meta4 = block5.getItemMeta();
									    								meta4.setLore(null);
									    								block5.setItemMeta(meta4);
									    								blocks = new ItemStack[]{block1, block2, block3, block4, block5};
									    								ItemStack block6;
									    								if (controlPanelWR.getButton(24) != null) {
									    									block6 = controlPanelWR.getButton(24).getItem();
									    									ItemMeta meta5 = block6.getItemMeta();
									    									meta5.setLore(null);
									    									block6.setItemMeta(meta5);
									    									blocks = new ItemStack[]{block1, block2, block3, block4, block5, block6};
									    									ItemStack block7;
									    									if (controlPanelWR.getButton(25) != null) {
									    										block7 = controlPanelWR.getButton(25).getItem();
									    										ItemMeta meta6 = block7.getItemMeta();
									    										meta6.setLore(null);
									    										block7.setItemMeta(meta6);
									    										blocks = new ItemStack[]{block1, block2, block3, block4, block5, block6, block7};
									    									}
									    								}
									    							}
									    						}
								    						}
							    						}
//							    						ItemStack block = controlPanelWR.getButton(22).getItem();
//							    						Utils.saveWallData(p.getUniqueId().toString(), block, false);
							    						PlayerWarps.getWarpBox().generateCubee(loc.clone().subtract(24.500, 15.00000, -2.500), new int[]{49, 58, 49}, new int[]{}, new int[]{7, 6, 0}, new int[]{}, new int[]{7, 1, 6}, blocks, Material.GLOWSTONE, Material.AIR, Material.GRASS, Material.STONE, Material.BEACON);
							    						if (PaginatedGUI.inSubMenu.get(p) == true) {
							    							PaginatedGUI.inSubMenu.remove(p);
							    						}
							    						if (p.getOpenInventory() != null) p.closeInventory();
							    						p.openInventory(controlPanel.getInventory());
							    						Utils.sendMessage(p, "&e&lWarp Create &aWarp room walls have been updated!");
							    					}
							    				}, 1L);
											});
											if (p.getOpenInventory() != null) p.closeInventory();
											p.openInventory(controlPanelWR.getInventory());
										}
									});
									
									controlPanel.addButton(editWarpRoomWalls);
									controlPanel.addButton(glassPane);
									List<String> editWarpLore = new ArrayList<String>();
									editWarpLore.add("");
									editWarpLore.add("&7This will make it so you stop editing your warp,");
									editWarpLore.add("&7and it will withdraw however much time you've used,");
									editWarpLore.add("&7and store the remaining time for further use.");
									editWarpLore.add("");
									editWarpLore.add("&a[Click to stop editing your warp]");
									GUIButton editWarp = new GUIButton(ItemBuilder.start(Material.BOOK_AND_QUILL).name("&e&lStop Editing").lore(editWarpLore).build());
									editWarp.setListener(event5 -> {
										event5.setCancelled(true);
										if (event5.getRawSlot() < event5.getInventory().getSize()) {
											if (p.getOpenInventory() != null) p.closeInventory();
											p.getInventory().clear();
											p.getInventory().setArmorContents(null);
											p.getOpenInventory().getTopInventory().clear();
											p.getOpenInventory().getBottomInventory().clear();
											p.setGameMode(GameMode.SURVIVAL);
											p.setGameMode(GameMode.SURVIVAL);
											p.setGameMode(GameMode.SURVIVAL);
											Utils.removeWarpBuilding(p.getUniqueId().toString());
										}
									});
									controlPanel.addButton(editWarp);
									for (int i = 17; i < 27; i++) {
										controlPanel.setButton(i, glassPane);
									}
									p.openInventory(controlPanel.getInventory());
									return;
								}
							}
							else {
								Utils.sendMessage(p, "&cYou must be the owner of this warp create to access the control panel.");
								return;
							}
					}
					else {
						Utils.sendMessage(p, "&cYou must be the owner of this warp create to access the control panel.");
						return;
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onClick1(InventoryClickEvent event) {
		Player player = (Player) event.getWhoClicked();
		if (PaginatedGUI.inSubMenu.containsKey(player)) {
			if (event.getInventory().getHolder() != null && event.getInventory().getHolder() instanceof PaginatedGUIAllPages) {
				PaginatedGUIAllPages inventory = (PaginatedGUIAllPages) event.getInventory().getHolder();
				if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + player.getUniqueId().toString()) != null) {
					if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
						if (event.getCurrentItem() == null || event.getCurrentItem().getType() == Material.AIR) return;
						if (PlayerWarps.get().getCustomData().getStringList("Blocked-Warp-Wall-Items") != null) {
							for (int i = 0; i < filterList.size(); i++) {
								String blacklisted = filterList.get(i);
								Material filter = Material.getMaterial(blacklisted);
								if (event.getCurrentItem().getType().equals(filter)) {
									Utils.sendMessage(player, "&cYou cannot use this item as a wall.");
									return;
								}
								else {
									continue;
								}
							}
							if ((event.getCurrentItem().getType().isSolid() && !event.getCurrentItem().getType().hasGravity() && event.getCurrentItem().getType().isBlock() || (event.getCurrentItem().getType().isTransparent() && event.getCurrentItem().getType() == Material.STAINED_GLASS || event.getCurrentItem().getType() == Material.GLASS || event.getCurrentItem().getType() == Material.GLOWSTONE || event.getCurrentItem().getType() == Material.REDSTONE_LAMP_OFF || event.getCurrentItem().getType() == Material.LEAVES || event.getCurrentItem().getType() == Material.LEAVES_2))) {
								double chance = 100;
//								blockLore.add("&7Click another block in your inventory");
//								blockLore.add("&7to change the composition.");
//								blockLore.add("&7Usage Chance: &a" + chance + "%");
//								blockLore.add("");
//								blockLore.add("&c[Click to remove]");
//								GUIButton block = new GUIButton(ItemBuilder.start(event.getCurrentItem().getType()).data((short)event.getCurrentItem().getDurability()).lore(blockLore).build());
//								block.setListener(event1 -> {
//									event1.setCancelled(true);
//								});
//								inventory.setButton(22, block);
								
								// Item setup in GUI
								List<String> blockLore = new ArrayList<String>();
								blockLore.add("&7Click another block in your inventory");
								blockLore.add("&7to change the composition.");
								blockLore.add("");
								blockLore.add("&c[Click to remove first block and move down one]");
								GUIButton block1 = new GUIButton(ItemBuilder.start(event.getCurrentItem().getType()).data((short)event.getCurrentItem().getDurability()).lore(blockLore).build());
								GUIButton block2 = new GUIButton(ItemBuilder.start(event.getCurrentItem().getType()).data((short)event.getCurrentItem().getDurability()).lore(blockLore).build());
								GUIButton block3 = new GUIButton(ItemBuilder.start(event.getCurrentItem().getType()).data((short)event.getCurrentItem().getDurability()).lore(blockLore).build());
								GUIButton block4 = new GUIButton(ItemBuilder.start(event.getCurrentItem().getType()).data((short)event.getCurrentItem().getDurability()).lore(blockLore).build());
								GUIButton block5 = new GUIButton(ItemBuilder.start(event.getCurrentItem().getType()).data((short)event.getCurrentItem().getDurability()).lore(blockLore).build());
								GUIButton block6 = new GUIButton(ItemBuilder.start(event.getCurrentItem().getType()).data((short)event.getCurrentItem().getDurability()).lore(blockLore).build());
								
								if (inventory.getButton(20) == null) {
									block1.setListener(event1 -> {
										event1.setCancelled(true);
										if (inventory.getButton(20) != null) {
											inventory.removeButton(19);
											GUIButton item1 = inventory.getButton(20);
											inventory.removeButton(20);
											inventory.setButton(19, item1);
											if (inventory.getButton(21) != null) {
												GUIButton item2 = inventory.getButton(21);
												inventory.removeButton(21);
												inventory.setButton(20, item2);
												if (inventory.getButton(22) != null) {
													GUIButton item3 = inventory.getButton(22);
													inventory.removeButton(22);
													inventory.setButton(21, item3);
													if (inventory.getButton(23) != null) {
														GUIButton item4 = inventory.getButton(23);
														inventory.removeButton(23);
														inventory.setButton(22, item4);
														if (inventory.getButton(24) != null) {
															GUIButton item5 = inventory.getButton(24);
															inventory.removeButton(24);
															inventory.setButton(23, item5);
															if (inventory.getButton(25) != null) {
																GUIButton item6 = inventory.getButton(25);
																inventory.removeButton(25);
																inventory.setButton(24, item6);
															}
														}
													}
												}
											}
										}
										else if (inventory.getButton(19) == block1 && inventory.getButton(20) == null) {
											Utils.sendMessage(player, "&cYou cannot remove this as their has to be at least 1 block selected.");
										}
									});
									
									// Make sure that it's only being added when it was a players bottom inventory.
									
									if (event.getWhoClicked().getOpenInventory().getBottomInventory() == event.getClickedInventory()) inventory.setButton(20, block1);
								}
								else if (inventory.getButton(21) == null) {	
									block2.setListener(event1 -> {
										event1.setCancelled(true);
										if (inventory.getButton(20) != null) {
											inventory.removeButton(19);
											GUIButton item1 = inventory.getButton(20);
											inventory.removeButton(20);
											inventory.setButton(19, item1);
											if (inventory.getButton(21) != null) {
												GUIButton item2 = inventory.getButton(21);
												inventory.removeButton(21);
												inventory.setButton(20, item2);
												if (inventory.getButton(22) != null) {
													GUIButton item3 = inventory.getButton(22);
													inventory.removeButton(22);
													inventory.setButton(21, item3);
													if (inventory.getButton(23) != null) {
														GUIButton item4 = inventory.getButton(23);
														inventory.removeButton(23);
														inventory.setButton(22, item4);
														if (inventory.getButton(24) != null) {
															GUIButton item5 = inventory.getButton(24);
															inventory.removeButton(24);
															inventory.setButton(23, item5);
															if (inventory.getButton(25) != null) {
																GUIButton item6 = inventory.getButton(25);
																inventory.removeButton(25);
																inventory.setButton(24, item6);
															}
														}
													}
												}
											}
										}
										else if (inventory.getButton(19) == block2 && inventory.getButton(20) == null) {
											Utils.sendMessage(player, "&cYou cannot remove this as their has to be at least 1 block selected.");
										}
									});
									
									// Make sure that it's only being added when it was a players bottom inventory.
									
									if (event.getWhoClicked().getOpenInventory().getBottomInventory() == event.getClickedInventory()) inventory.setButton(21, block2);
								}
								else if (inventory.getButton(22) == null) {	
									block3.setListener(event1 -> {
										event1.setCancelled(true);
										if (inventory.getButton(20) != null) {
											inventory.removeButton(19);
											GUIButton item1 = inventory.getButton(20);
											inventory.removeButton(20);
											inventory.setButton(19, item1);
											if (inventory.getButton(21) != null) {
												GUIButton item2 = inventory.getButton(21);
												inventory.removeButton(21);
												inventory.setButton(20, item2);
												if (inventory.getButton(22) != null) {
													GUIButton item3 = inventory.getButton(22);
													inventory.removeButton(22);
													inventory.setButton(21, item3);
													if (inventory.getButton(23) != null) {
														GUIButton item4 = inventory.getButton(23);
														inventory.removeButton(23);
														inventory.setButton(22, item4);
														if (inventory.getButton(24) != null) {
															GUIButton item5 = inventory.getButton(24);
															inventory.removeButton(24);
															inventory.setButton(23, item5);
															if (inventory.getButton(25) != null) {
																GUIButton item6 = inventory.getButton(25);
																inventory.removeButton(25);
																inventory.setButton(24, item6);
															}
														}
													}
												}
											}
										}
										else if (inventory.getButton(19) == block3 && inventory.getButton(20) == null) {
											Utils.sendMessage(player, "&cYou cannot remove this as their has to be at least 1 block selected.");
										}
									});
									
									// Make sure that it's only being added when it was a players bottom inventory.
									
									if (event.getWhoClicked().getOpenInventory().getBottomInventory() == event.getClickedInventory()) inventory.setButton(22, block3);
								}
								else if (inventory.getButton(23) == null) {	
									block4.setListener(event1 -> {
										event1.setCancelled(true);
										if (inventory.getButton(20) != null) {
											inventory.removeButton(19);
											GUIButton item1 = inventory.getButton(20);
											inventory.removeButton(20);
											inventory.setButton(19, item1);
											if (inventory.getButton(21) != null) {
												GUIButton item2 = inventory.getButton(21);
												inventory.removeButton(21);
												inventory.setButton(20, item2);
												if (inventory.getButton(22) != null) {
													GUIButton item3 = inventory.getButton(22);
													inventory.removeButton(22);
													inventory.setButton(21, item3);
													if (inventory.getButton(23) != null) {
														GUIButton item4 = inventory.getButton(23);
														inventory.removeButton(23);
														inventory.setButton(22, item4);
														if (inventory.getButton(24) != null) {
															GUIButton item5 = inventory.getButton(24);
															inventory.removeButton(24);
															inventory.setButton(23, item5);
															if (inventory.getButton(25) != null) {
																GUIButton item6 = inventory.getButton(25);
																inventory.removeButton(25);
																inventory.setButton(24, item6);
															}
														}
													}
												}
											}
										}
										else if (inventory.getButton(19) == block4 && inventory.getButton(20) == null) {
											Utils.sendMessage(player, "&cYou cannot remove this as their has to be at least 1 block selected.");
										}
									});
									
									// Make sure that it's only being added when it was a players bottom inventory.
									
									if (event.getWhoClicked().getOpenInventory().getBottomInventory() == event.getClickedInventory()) inventory.setButton(23, block4);
								}
								else if (inventory.getButton(24) == null) {	
									block5.setListener(event1 -> {
										event1.setCancelled(true);
										if (inventory.getButton(20) != null) {
											inventory.removeButton(19);
											GUIButton item1 = inventory.getButton(20);
											inventory.removeButton(20);
											inventory.setButton(19, item1);
											if (inventory.getButton(21) != null) {
												GUIButton item2 = inventory.getButton(21);
												inventory.removeButton(21);
												inventory.setButton(20, item2);
												if (inventory.getButton(22) != null) {
													GUIButton item3 = inventory.getButton(22);
													inventory.removeButton(22);
													inventory.setButton(21, item3);
													if (inventory.getButton(23) != null) {
														GUIButton item4 = inventory.getButton(23);
														inventory.removeButton(23);
														inventory.setButton(22, item4);
														if (inventory.getButton(24) != null) {
															GUIButton item5 = inventory.getButton(24);
															inventory.removeButton(24);
															inventory.setButton(23, item5);
															if (inventory.getButton(25) != null) {
																GUIButton item6 = inventory.getButton(25);
																inventory.removeButton(25);
																inventory.setButton(24, item6);
															}
														}
													}
												}
											}
										}
										else if (inventory.getButton(19) == block5 && inventory.getButton(20) == null) {
											Utils.sendMessage(player, "&cYou cannot remove this as their has to be at least 1 block selected.");
										}
									});
									
									// Make sure that it's only being added when it was a players bottom inventory.
									
									if (event.getWhoClicked().getOpenInventory().getBottomInventory() == event.getClickedInventory()) inventory.setButton(24, block5);
								}
								else if (inventory.getButton(25) == null) {	
									block6.setListener(event1 -> {
										event1.setCancelled(true);
										if (inventory.getButton(20) != null) {
											inventory.removeButton(19);
											GUIButton item1 = inventory.getButton(20);
											inventory.removeButton(20);
											inventory.setButton(19, item1);
											if (inventory.getButton(21) != null) {
												GUIButton item2 = inventory.getButton(21);
												inventory.removeButton(21);
												inventory.setButton(20, item2);
												if (inventory.getButton(22) != null) {
													GUIButton item3 = inventory.getButton(22);
													inventory.removeButton(22);
													inventory.setButton(21, item3);
													if (inventory.getButton(23) != null) {
														GUIButton item4 = inventory.getButton(23);
														inventory.removeButton(23);
														inventory.setButton(22, item4);
														if (inventory.getButton(24) != null) {
															GUIButton item5 = inventory.getButton(24);
															inventory.removeButton(24);
															inventory.setButton(23, item5);
															if (inventory.getButton(25) != null) {
																GUIButton item6 = inventory.getButton(25);
																inventory.removeButton(25);
																inventory.setButton(24, item6);
															}
														}
													}
												}
											}
										}
										else if (inventory.getButton(19) == block6 && inventory.getButton(20) == null) {
											Utils.sendMessage(player, "&cYou cannot remove this as their has to be at least 1 block selected.");
										}
									});
									
									// Make sure that it's only being added when it was a players bottom inventory.
									
									if (event.getWhoClicked().getOpenInventory().getBottomInventory() == event.getClickedInventory()) inventory.setButton(25, block6);
								}
								else {
									Utils.sendMessage(player, "&cYou have hit the limit of how many blocks can be used.");
								}
								
								// Re add the listener to the first block as it's removed.
								
								GUIButton block11 = inventory.getButton(19);	
								block11.setListener(e2 -> {
									e2.setCancelled(true);
									if (inventory.getButton(20) != null) {
										inventory.removeButton(19);
										GUIButton item1 = inventory.getButton(20);
										inventory.removeButton(20);
										inventory.setButton(19, item1);
										if (inventory.getButton(21) != null) {
											GUIButton item2 = inventory.getButton(21);
											inventory.removeButton(21);
											inventory.setButton(20, item2);
											if (inventory.getButton(22) != null) {
												GUIButton item3 = inventory.getButton(22);
												inventory.removeButton(22);
												inventory.setButton(21, item3);
												if (inventory.getButton(23) != null) {
													GUIButton item4 = inventory.getButton(23);
													inventory.removeButton(23);
													inventory.setButton(22, item4);
													if (inventory.getButton(24) != null) {
														GUIButton item5 = inventory.getButton(24);
														inventory.removeButton(24);
														inventory.setButton(23, item5);
														if (inventory.getButton(25) != null) {
															GUIButton item6 = inventory.getButton(25);
															inventory.removeButton(25);
															inventory.setButton(24, item6);
														}
													}
												}
											}
										}
									}
									else {
										Utils.sendMessage(player, "&cYou cannot remove this as there has to be at least 1 block selected.");
									}
								});
								inventory.refreshInventory(player);
							}
							else {
								Utils.sendMessage(player, "&cYou cannot use this item as a wall.");
								return;
							}
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onClick(PlayerInteractEvent event) {
		ItemStack wcblock1;
		String timeLength = "";
		String antiDupeString = "";
		
		
		wcblock1 = new ItemStack(Material.LAPIS_BLOCK);
		List<String> wclore1 = new ArrayList<String>();
		wclore1.add(Utils.replace("&3This is a WarpCreate."));
		wclore1.add(Utils.replace("&3WarpCreates allow the player with"));
		wclore1.add(Utils.replace("&3this item to create a PlayerWarp."));
		wclore1.add(Utils.replace("&3This will clear your inventory so put away any other items."));
		if (event.getItem() == null || event.getItem().getType() == Material.AIR) return;
		if (ItemMetadata.hasMetadata(event.getItem(), "WarpCreate")) {
			if (ItemMetadata.getMetadata(event.getItem(), "WarpCreate") instanceof String) {
				timeLength = (String) ItemMetadata.getMetadata(event.getItem(), "WarpCreate");
				wcblock1 = ItemMetadata.setMetadata(wcblock1, "WarpCreate", timeLength);
			}
			else {
				return;
			}
		}
		else {
			return;
		}
		if (ItemMetadata.hasMetadata(event.getItem(), "AntiDupe")) {
			event.setCancelled(true);
			if (ItemMetadata.getMetadata(event.getItem(), "AntiDupe") instanceof String) {
				antiDupeString = (String) ItemMetadata.getMetadata(event.getItem(), "AntiDupe");
				wcblock1 = ItemMetadata.setMetadata(wcblock1, "AntiDupe", antiDupeString);
			}
			else {
				return;
			}
		}
		else {
			return;
		}
		wclore1.add(Utils.replace("&7[&eRight-Click this to create a " + timeLength + " WarpCreate&7]"));
		ItemMeta im1 = wcblock1.getItemMeta();
		im1.setDisplayName(Utils.replace("&3WarpCreate &7[&3" + timeLength + "&7]"));
		im1.setLore(wclore1);
		wcblock1.setItemMeta(im1);
		
		
		if (wcblock1.equals(event.getItem())) {
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + event.getPlayer().getUniqueId().toString()) != null) {
				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + event.getPlayer().getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + event.getPlayer().getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
					Utils.sendMessage(event.getPlayer(), "&cYou cannot create a playerwarp while you are making one.");
				}
				else {
					if (Utils.getUsedWarpCreate(antiDupeString)) {
						event.getPlayer().getInventory().remove(wcblock1);
						Bukkit.dispatchCommand(Bukkit.getConsoleSender(), PlayerWarps.get().getCustomData().getString("Duped-WarpCreate-Punishment").replaceAll("%player%", event.getPlayer().getName()).replaceAll("%id%", antiDupeString));
						return;
					}
					else {
						Utils.saveUsedWarpCreate(antiDupeString);
						Utils.sendMessage(event.getPlayer(), "&6&lWarp Create &eID: &a" + antiDupeString + "&e.");
						Utils.sendMessage(event.getPlayer(), "&eYou've successfully added &6" + timeLength + " &eof edit time to your warp.");
						Utils.sendMessage(event.getPlayer(), "&eYou may start editing your warp by accessing the &6control panel &eblock at your warp.");
						Utils.sendMessage(event.getPlayer(), "&eTo go to your warp issue the follow command: &6/pw " + event.getPlayer().getName());
					}
					int time = 0;
					if (timeLength.contains("h")) {
						time = Integer.parseInt(timeLength.replace("h", "")) * 3600;
					}
					else if (timeLength.contains("m")) {
						time = Integer.parseInt(timeLength.replace("m", "")) * 60;
					}
					else if (timeLength.contains("s")) {
						time = Integer.parseInt(timeLength.replace("s", ""));
					}
					Date now = new Date();
					SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
					
					Utils.saveEditTime(event.getPlayer().getUniqueId().toString(), time, "(+" + timeLength + ") " + format.format(now), "true");
					event.getPlayer().getInventory().remove(wcblock1);
				}
			}
			else if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + event.getPlayer().getUniqueId().toString()) == null) {
				if (Utils.getUsedWarpCreate(antiDupeString)) {
					event.getPlayer().getInventory().remove(wcblock1);
					Bukkit.dispatchCommand(Bukkit.getConsoleSender(), PlayerWarps.get().getCustomData().getString("Duped-WarpCreate-Punishment").replaceAll("%player%", event.getPlayer().getName()).replaceAll("%id%", antiDupeString));
					return;
				}
				else {
					Utils.saveUsedWarpCreate(antiDupeString);
					Utils.sendMessage(event.getPlayer(), "&6&lWarp Create &eID: &a" + antiDupeString + "&e.");
					Utils.sendMessage(event.getPlayer(), "&eYou've successfully &a&lcreated &eand added &6" + timeLength + " &eof edit time to your warp.");
					Utils.sendMessage(event.getPlayer(), "&eYou may start editing your warp by accessing the &6control panel &eblock at your warp.");
					Utils.sendMessage(event.getPlayer(), "&eTo go to your warp issue the follow command: &6/pw " + event.getPlayer().getName());
				}
				int time = 0;
				if (timeLength.contains("h")) {
					time = Integer.parseInt(timeLength.replace("h", "")) * 3600;
				}
				else if (timeLength.contains("m")) {
					time = Integer.parseInt(timeLength.replace("m", "")) * 60;
				}
				else if (timeLength.contains("s")) {
					time = Integer.parseInt(timeLength.replace("s", ""));
				}
				Date now = new Date();
				SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
				
				Utils.saveEditTime(event.getPlayer().getUniqueId().toString(), time, "(+" + timeLength + ") " + format.format(now), "true");
				PlayerWarps.get().getWorldSetup().createWarp(event.getPlayer());
				event.getPlayer().getInventory().remove(wcblock1);
			}
		}
	}
	
	@EventHandler
	public void onAttack(EntityDamageByEntityEvent event) {
		if (event.getEntity() instanceof Player) {
			if (event.getDamager() instanceof Player) {
				Player victim = (Player) event.getEntity();
				Player damager = (Player) event.getDamager();
				if (victim.getWorld().getName().startsWith("PlayerWarp") && damager.getWorld().getName().startsWith("PlayerWarp")) {
					Location loc;
					Location loc2;
					if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
						Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
						for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
							UUID uuid = UUID.fromString(it.next());
							OfflinePlayer target = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid);
							if (target.hasPlayedBefore() || target != null) {
								if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + uuid.toString()) != null) {
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".xb") != null) {
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".yb") != null) {
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".zb") != null) {
												loc = Utils.getPlayerWarpLocation(target.getUniqueId().toString());
												loc2 = loc.clone().subtract(44, 15, -2).add(48, 13, -7);
												if (Zone.contains(victim.getLocation(), loc2.getBlockX(), loc2.getBlockX() - 7, -6, 0)) {
													event.setCancelled(true);
													Utils.sendMessage(damager, "&cYou cannot pvp someone in a safezone.");
												}
											}
										}									
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onInteract(EntityDamageByEntityEvent event) {
		if (event.getEntity() instanceof Player) {
			Player victim = (Player) event.getEntity();
			if (event.getDamager() instanceof Player) {
				if (victim.getWorld().getName().startsWith("PlayerWarp")) {
					Location loc;
					Location loc2;
					if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
						Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
						for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
							UUID uuid = UUID.fromString(it.next());
							OfflinePlayer target = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid);
							if (target.hasPlayedBefore() || target != null) {
								if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + uuid.toString()) != null) {
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".xb") != null) {
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".yb") != null) {
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".zb") != null) {
												loc = Utils.getPlayerWarpLocation(target.getUniqueId().toString());
												loc2 = loc.clone().subtract(44, 15, -2).add(48, 13, -7);
												if (Zone.contains(victim.getLocation(), loc2.getBlockX(), loc2.getBlockX() - 7, -6, 0)) {
													if (event.getCause() == DamageCause.PROJECTILE) {
														event.setCancelled(true);
														Utils.sendMessage(event.getDamager(), "&cYou cannot pvp in a safezone.");
													}
													else {
														if (event.getCause() == DamageCause.PROJECTILE) {
															event.setCancelled(true);
															Utils.sendMessage(event.getDamager(), "&cYou cannot pvp in a safezone.");
														}
													}
												}
											}
										}									
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onInteract(EntityDamageEvent event) {
		if (event.getEntity() instanceof Player) {
			Player victim = (Player) event.getEntity();
			if (victim.getWorld().getName().startsWith("PlayerWarp")) {
				Location loc;
				Location loc2;
				if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
					Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
					for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
						UUID uuid = UUID.fromString(it.next());
						OfflinePlayer target = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid);
						if (target.hasPlayedBefore() || target != null) {
							if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + uuid.toString()) != null) {
								if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".xb") != null) {
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".yb") != null) {
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".zb") != null) {
											loc = Utils.getPlayerWarpLocation(target.getUniqueId().toString());
											loc2 = loc.clone().subtract(44, 15, -2).add(48, 13, -7);
											if (Zone.contains(victim.getLocation(), loc2.getBlockX(), loc2.getBlockX() - 7, -6, 0)) {
												event.setCancelled(true);
											}
										}
									}									
								}
							}
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onShoot(ProjectileLaunchEvent event) {
		if (event.getEntity().getShooter() instanceof Player) {
			if (event.getEntity() instanceof Arrow) {
				Player player = (Player) event.getEntity().getShooter();
				Location loc;
				Location loc2;
				if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
					Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
					for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
						UUID uuid = UUID.fromString(it.next());
						OfflinePlayer target = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid);
						if (target != null) {
							if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + uuid.toString()) != null) {
								if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".xb") != null) {
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".yb") != null) {
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".zb") != null) {
											loc = Utils.getPlayerWarpLocation(target.getUniqueId().toString());
											loc2 = loc.clone().subtract(44, 15, -2).add(48, 13, -7);
											if (Zone.contains(player.getLocation(), loc2.getBlockX(), loc2.getBlockX() - 7, -6, 0)) {
												event.setCancelled(true);
												Utils.sendMessage(player, "&cYou cannot use a bow in a safezone.");
											}
										}
									}									
								}
							}
						}
					}
				}
			}
		}
	}
	
	
	private boolean isFull(ItemStack... items) {
		for (ItemStack item : items) {
			
			if (item != null && item.getType() != Material.AIR) {
				if (ItemMetadata.hasMetadata(item, "WarpCreate")) {
					if (ItemMetadata.getMetadata(item, "WarpCreate") instanceof String) {
						return false;
					}
					else {
						return true;
					}
				}
				else {
					return true;
				}
//				if (!item.getItemMeta().getDisplayName().startsWith(Utils.replace("&3WarpCreate &7[&3"))) {
//					return true;
//				}
			}
		}
		return false;
	}
	
	@EventHandler
	public void noFlyRegion(PlayerMoveEvent event) {
		Player player = (Player) event.getPlayer();
		Location loc = player.getLocation();
		if (isWithinRegion(player, PlayerWarps.get().getCustomData().getString("AntiFly-Region"))) {
			if (player.isFlying()) {
				return;
			}
		} else {
			if (player.isFlying()) {
				if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
					if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + event.getPlayer().getUniqueId().toString()) != null) {
						if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + event.getPlayer().getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + event.getPlayer().getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
							return;
						}
					}
				}
				if (!player.hasPermission("antiflyzone.bypass")) {
					Utils.sendMessage(player, "&7[&6ANTIFLY&7] &cYou cannot fly here.");
					player.setAllowFlight(false);
					player.setFlying(false);
				} else {
					return;
				}
			}
		}
	}
}
