package str.playerwarps.listener;

import java.text.SimpleDateFormat;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.OfflinePlayer;
import org.bukkit.World;
import org.bukkit.WorldCreator;
import org.bukkit.WorldType;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;

import org.bukkit.potion.PotionEffect;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitScheduler;
import org.bukkit.scheduler.BukkitTask;

import str.playerwarps.PlayerWarps;
import str.playerwarps.util.ScoreboardWrapper;
import str.playerwarps.util.Utils;
import str.playerwarps.util.Zone;

public class WorldListener implements Listener {
	
	
	private static BukkitTask scoreboard;
	
	public static HashMap<Player, Boolean> toggleBuild = new HashMap<Player, Boolean>();
	public static HashMap<Player, Boolean> building = new HashMap<Player, Boolean>();
	public static HashMap<OfflinePlayer, Boolean> ready = new HashMap<OfflinePlayer, Boolean>();
	public static HashMap<Player, Boolean> prevent = new HashMap<Player, Boolean>();
	public static HashMap<Player, Boolean> confirm = new HashMap<Player, Boolean>();
	
	public static void createVoidWorld(Player player, boolean notify, int timelimit) {
		String worldname = "PlayerWarps-World";
		Location loc;
		Location loc2;
		World mainworld = Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world"));
		if (Bukkit.getWorld(worldname) != null) {
			String UUID = player.getUniqueId().toString();
			if (Utils.getPlayerWarpLocation(UUID) != null) {
				Location loc1 = Utils.getPlayerWarpLocation(UUID);
				for (Player players : Bukkit.getWorld(worldname).getPlayers()) {
					if (!players.getName().equalsIgnoreCase(player.getName())) {
						if (mainworld != null) {
							if (Zone.contains(players.getLocation(), loc1.getBlockX() + 25, loc1.getBlockX() + 20 - 69, -7, 66)) {
								players.teleport(mainworld.getSpawnLocation());
								Utils.sendMessage(players, "&6" + player.getName() + " &eis editing their playerwarp!");
							}
						}
					}
				}
				player.teleport(loc1);
				Utils.saveEditingWarp(UUID);
			}


			player.getInventory().clear();
			player.setGameMode(GameMode.CREATIVE);
			Bukkit.getPlayer(player.getName()).setGameMode(GameMode.CREATIVE);
			for (PotionEffect effects : player.getActivePotionEffects()) {
				player.removePotionEffect(effects.getType());
			}
			
			Utils.sendMessage(player, "&6&lWarp Create &eYou've started to edit your warp with &6" + Utils.formatSeconds(timelimit) + " &eremaining.");
			Utils.sendMessage(player, "&6&lWarp Create &eYou may open the control panel to stop editing your warp.");
			ScoreboardWrapper initSB1 = new ScoreboardWrapper(Utils.replace(PlayerWarps.get().getCustomData().getString("Server-name")));
			initSB1.addLine(Utils.replace("&7&m-------------------"));
			initSB1.addLine(Utils.replace("&6&lWarp Create"));
			initSB1.addLine(Utils.replace(" &e&l* &fTime Available:"));
			initSB1.addBlankSpace();
			initSB1.addBlankSpace();
			initSB1.addLine(Utils.replace("&7You can stop editing"));
			initSB1.addLine(Utils.replace("&7by opening the"));
			initSB1.addLine(Utils.replace("&7control panel."));
			initSB1.addLine(Utils.replace("&7&m-------------------"));
			if (PlayerWarps.get().getFeatherboardSupport()) {
				Bukkit.dispatchCommand(Bukkit.getConsoleSender(), "fb off " + player.getName());
			}
			player.setScoreboard(initSB1.getScoreboard());
			Utils.saveWarpBuilding(UUID);
			new BukkitRunnable() {
				int seconds = timelimit;
				@Override
				public void run() {
					if (seconds % 60 == 0) {
						Utils.sendMessage(player, "&6&lWarp Create &6" + Utils.formatSeconds(seconds) + " &aleft.");
					}
					if (seconds > 0) {
						seconds--;
						String formatBoardSec = Utils.formatSeconds(seconds);
						initSB1.setLine(3, Utils.replace(" &e&l* &3" + formatBoardSec));
						if (Bukkit.getServer().getPlayer(player.getName()) == null) {
							this.cancel();
							Date now = new Date();
							SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
							
							Utils.saveEditTime(player.getUniqueId().toString(), seconds, "(-" + Utils.formatSeconds(Long.valueOf(timelimit - seconds)) + ") " + format.format(now), "false");
							endSb(player);
						}
						if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + player.getUniqueId().toString()) != null) {
							if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building").equalsIgnoreCase("false")) {
								this.cancel();
								player.setGameMode(GameMode.SURVIVAL);
								player.setGameMode(GameMode.SURVIVAL);
								endSb(player);
								if (Bukkit.getServer().getPlayer(player.getName()) != null) {
									Date now = new Date();
									SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
									
									Utils.saveEditTime(player.getUniqueId().toString(), seconds, "(-" + Utils.formatSeconds(Long.valueOf(timelimit - seconds)) + ") " + format.format(now), "false");
									Utils.sendMessage(player, "&6&lWarp Create &eYou've ended your editing session in your warp with &6" + Utils.formatSeconds(seconds) + " &eremaining for further use.");
									Utils.sendMessage(player, "&6&lWarp Create &eYou may open the control panel to start editing your warp again.");
									Utils.sendMessage(player, "&6&lWarp Create &eStaff will approve your warp once they look at it.");
								}
							}
						}
						else {
							this.cancel();
							player.setGameMode(GameMode.SURVIVAL);
							player.setGameMode(GameMode.SURVIVAL);
							endSb(player);
							if (Bukkit.getServer().getPlayer(player.getName()) != null) {
								Utils.deleteWarpTransactions(player.getUniqueId().toString());
								Utils.sendMessage(player, "&6&lWarp Create &cYour warp was forcefully deleted.");
								Utils.sendMessage(player, "&6&lWarp Create &cPlease contact staff if you think this was a mistake.");
							}
						}
					}
					else {
						this.cancel();
						player.setGameMode(GameMode.SURVIVAL);
						player.setGameMode(GameMode.SURVIVAL);
						Date now = new Date();
						SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
						
						Utils.saveEditTime(player.getUniqueId().toString(), 0, "(-" + Utils.formatSeconds(Long.valueOf(timelimit - seconds)) + ") " + format.format(now), "false");
						Utils.sendMessage(player, "&6&lWarp Create &eYou've ended your editing session in your warp with &6" + Utils.formatSeconds(seconds) + " &eremaining.");
						Utils.sendMessage(player, "&6&lWarp Create &eStaff will approve your warp once they look at it.");
						endSb(player);
					}
				}
			}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
			toggleBuild.put(player, true);
			building.put(player, true);
			prevent.put(player, true);
			player.setScoreboard(initSB1.getScoreboard());
			PlayerWarps.get().reloadConfig();
		}
		else {
			
			player.getInventory().clear();
			player.setGameMode(GameMode.CREATIVE);
			Bukkit.getPlayer(player.getName()).setGameMode(GameMode.CREATIVE);
			for (PotionEffect effects : player.getActivePotionEffects()) {
				player.removePotionEffect(effects.getType());
			}
			Utils.sendMessage(player, "&6&lWarp Create &eYou've started to edit your warp with &6" + Utils.formatSeconds(timelimit) + " &eremaining.");
			Utils.sendMessage(player, "&6&lWarp Create &eYou may open the control panel to stop editing your warp.");
			ScoreboardWrapper initSB1 = new ScoreboardWrapper(Utils.replace(PlayerWarps.get().getCustomData().getString("Server-name")));
			initSB1.addLine(Utils.replace("&7&m-------------------"));
			initSB1.addLine(Utils.replace("&6&lWarpCreate"));
			initSB1.addLine(Utils.replace(" &e&l* &fTime Available:"));
			initSB1.addBlankSpace();
			initSB1.addBlankSpace();
			initSB1.addLine(Utils.replace("&7You can stop editing"));
			initSB1.addLine(Utils.replace("&7by opening the"));
			initSB1.addLine(Utils.replace("&7control panel."));
			initSB1.addLine(Utils.replace("&7&m-------------------"));
			if (PlayerWarps.get().getFeatherboardSupport()) {
				Bukkit.dispatchCommand(Bukkit.getConsoleSender(), "fb off " + player.getName());
			}
			player.setScoreboard(initSB1.getScoreboard());
			new BukkitRunnable() {
				int seconds = timelimit;
				@Override
				public void run() {
					if (seconds % 60 == 0) {
						Utils.sendMessage(player, "&6&lWarp Create &6" + Utils.formatSeconds(seconds) + " &aleft.");
					}
					if (seconds > 0) {
						seconds--;
						String formatBoardSec = Utils.formatSeconds(seconds);
						initSB1.setLine(3, Utils.replace(" &e&l* &3" + formatBoardSec));
						if (Bukkit.getServer().getPlayer(player.getName()) == null) {
							this.cancel();
							player.setGameMode(GameMode.SURVIVAL);
							player.setGameMode(GameMode.SURVIVAL);
							player.getInventory().clear();
							player.getOpenInventory().getBottomInventory().clear();
							player.getOpenInventory().getTopInventory().clear();
							Date now = new Date();
							SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
							
							Utils.saveEditTime(player.getUniqueId().toString(), seconds, "(-" + Utils.formatSeconds(Long.valueOf(timelimit - seconds)) + ") " + format.format(now), "false");
							endSb(player);
						}
						if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + player.getUniqueId().toString()) != null) {
							if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Building").equalsIgnoreCase("false")) {
								this.cancel();
								endSb(player);
								if (Bukkit.getServer().getPlayer(player.getName()) != null) {
									player.setGameMode(GameMode.SURVIVAL);
									player.setGameMode(GameMode.SURVIVAL);
									player.getInventory().clear();
									player.getOpenInventory().getBottomInventory().clear();
									player.getOpenInventory().getTopInventory().clear();
									Date now = new Date();
									SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
									
									Utils.saveEditTime(player.getUniqueId().toString(), seconds, "(-" + Utils.formatSeconds(Long.valueOf(timelimit - seconds)) + ") " + format.format(now), "false");
									Utils.sendMessage(player, "&6&lWarp Create &eYou've ended your editing session in your warp with &6" + Utils.formatSeconds(seconds) + " &eremaining for further use.");
									Utils.sendMessage(player, "&6&lWarp Create &eYou may open the control panel to start editing your warp again.");
									Utils.sendMessage(player, "&6&lWarp Create &eStaff will approve your warp once they look at it.");
								}
							}
						}
						else {
							this.cancel();
							endSb(player);
							if (Bukkit.getServer().getPlayer(player.getName()) != null) {
								player.setGameMode(GameMode.SURVIVAL);
								player.setGameMode(GameMode.SURVIVAL);
								player.getInventory().clear();
								player.getOpenInventory().getBottomInventory().clear();
								player.getOpenInventory().getTopInventory().clear();
								Utils.deleteWarpTransactions(player.getUniqueId().toString());
								Utils.sendMessage(player, "&6&lWarp Create &cYour warp was forcefully deleted.");
								Utils.sendMessage(player, "&6&lWarp Create &cPlease contact staff if you think this was a mistake.");
							}
						}
					}
					else {
						this.cancel();
						player.setGameMode(GameMode.SURVIVAL);
						player.setGameMode(GameMode.SURVIVAL);
						player.getInventory().clear();
						player.getOpenInventory().getBottomInventory().clear();
						player.getOpenInventory().getTopInventory().clear();
						Date now = new Date();
						SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
						
						Utils.saveEditTime(player.getUniqueId().toString(), 0, "(-" + Utils.formatSeconds(Long.valueOf(timelimit - seconds)) + ") " + format.format(now), "false");
						Utils.sendMessage(player, "&6&lWarp Create &eYou've ended your editing session in your warp with &6" + Utils.formatSeconds(seconds) + " &eremaining.");
						Utils.sendMessage(player, "&6&lWarp Create &eStaff will approve your warp once they look at it.");
						endSb(player);
					}
				}
			}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//			new BukkitRunnable() {
//				int seconds = 1;
//				@Override
//				public void run() {
//					if (seconds > 0) {
//						seconds--;
//						player.setGameMode(GameMode.CREATIVE);
//						Bukkit.getPlayer(player.getName()).setGameMode(GameMode.CREATIVE);
//						PlayerWarps.get().reloadConfig();
//					}
//					else {
//						this.cancel();
//					}
//				}
//			}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//			if (timelimit == 20 * 60) {
//				new BukkitRunnable() {
//					int seconds = timelimit;
//					@Override
//					public void run() {
//						if (seconds % 60 == 0) {
//							Utils.sendMessage(player, "&3" + Utils.formatSeconds(seconds) + " &eleft.");
//						}
//						if (seconds > 0) {
//							seconds--;
//							String formatBoardSec = Utils.formatSeconds(seconds);
//							initSB1.setLine(2, ChatColor.DARK_AQUA + "" + formatBoardSec);
//							if (Bukkit.getServer().getPlayer(player.getName()) == null) {
//								this.cancel();
//								endSb(player);
//							}
//						}
//						else {
//							this.cancel();
//							endSb(player);
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//				new BukkitRunnable() {
//					int seconds = 3;
//					@Override
//					public void run() {
//						if (seconds > 0) {
//							seconds--;
//							player.setGameMode(GameMode.CREATIVE);
//							Bukkit.getPlayer(player.getName()).setGameMode(GameMode.CREATIVE);
//							PlayerWarps.get().reloadConfig();
//						}
//						else {
//							this.cancel();
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//			}
//			if (timelimit == 30 * 60) {
//				new BukkitRunnable() {
//					int seconds = timelimit;
//					@Override
//					public void run() {
//						if (seconds % 60 == 0) {
//							Utils.sendMessage(player, "&3" + Utils.formatSeconds(seconds) + " &eleft.");
//						}
//						if (seconds > 0) {
//							seconds--;
//							String formatBoardSec = Utils.formatSeconds(seconds);
//							initSB1.setLine(2, ChatColor.DARK_AQUA + "" + formatBoardSec);
//							if (Bukkit.getServer().getPlayer(player.getName()) == null) {
//								this.cancel();
//								endSb(player);
//							}
//						}
//						else {
//							this.cancel();
//							endSb(player);
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//				new BukkitRunnable() {
//					int seconds = 3;
//					@Override
//					public void run() {
//						if (seconds > 0) {
//							seconds--;
//							player.setGameMode(GameMode.CREATIVE);
//							Bukkit.getPlayer(player.getName()).setGameMode(GameMode.CREATIVE);
//							PlayerWarps.get().reloadConfig();
//						}
//						else {
//							this.cancel();
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//			}
//			if (timelimit == 90 * 60) {
//				new BukkitRunnable() {
//					int seconds = timelimit;
//					@Override
//					public void run() {
//						if (seconds % 60 == 0) {
//							Utils.sendMessage(player, "&3" + Utils.formatSeconds(seconds) + " &eleft.");
//						}
//						if (seconds > 0) {
//							seconds--;
//							String formatBoardSec = Utils.formatSeconds(seconds);
//							initSB1.setLine(2, ChatColor.DARK_AQUA + "" + formatBoardSec);
//							if (Bukkit.getServer().getPlayer(player.getName()) == null) {
//								this.cancel();
//								endSb(player);
//							}
//						}
//						else {
//							this.cancel();
//							endSb(player);
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//				new BukkitRunnable() {
//					int seconds = 3;
//					@Override
//					public void run() {
//						if (seconds > 0) {
//							seconds--;
//							player.setGameMode(GameMode.CREATIVE);
//							Bukkit.getPlayer(player.getName()).setGameMode(GameMode.CREATIVE);
//							PlayerWarps.get().reloadConfig();
//						}
//						else {
//							this.cancel();
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//			}
//			if (timelimit == 40 * 60) {
//				new BukkitRunnable() {
//					int seconds = timelimit;
//					@Override
//					public void run() {
//						if (seconds % 60 == 0) {
//							Utils.sendMessage(player, "&3" + Utils.formatSeconds(seconds) + " &eleft.");
//						}
//						if (seconds > 0) {
//							seconds--;
//							String formatBoardSec = Utils.formatSeconds(seconds);
//							initSB1.setLine(2, ChatColor.DARK_AQUA + "" + formatBoardSec);
//							if (Bukkit.getServer().getPlayer(player.getName()) == null) {
//								this.cancel();
//								endSb(player);
//							}
//						}
//						else {
//							this.cancel();
//							endSb(player);
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//				new BukkitRunnable() {
//					int seconds = 3;
//					@Override
//					public void run() {
//						if (seconds > 0) {
//							seconds--;
//							player.setGameMode(GameMode.CREATIVE);
//							Bukkit.getPlayer(player.getName()).setGameMode(GameMode.CREATIVE);
//							PlayerWarps.get().reloadConfig();
//						}
//						else {
//							this.cancel();
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//			}
//			if (timelimit == 60 * 60) {
//				new BukkitRunnable() {
//					int seconds = timelimit;
//					@Override
//					public void run() {
//						if (seconds % 60 == 0) {
//							Utils.sendMessage(player, "&3" + Utils.formatSeconds(seconds) + " &eleft.");
//						}
//						if (seconds > 0) {
//							seconds--;
//							String formatBoardSec = Utils.formatSeconds(seconds);
//							initSB1.setLine(2, ChatColor.DARK_AQUA + "" + formatBoardSec);
//							if (Bukkit.getServer().getPlayer(player.getName()) == null) {
//								this.cancel();
//								endSb(player);
//							}
//						}
//						else {
//							this.cancel();
//							endSb(player);
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//				new BukkitRunnable() {
//					int seconds = 3;
//					@Override
//					public void run() {
//						if (seconds > 0) {
//							seconds--;
//							player.setGameMode(GameMode.CREATIVE);
//							Bukkit.getPlayer(player.getName()).setGameMode(GameMode.CREATIVE);
//							PlayerWarps.get().reloadConfig();
//						}
//						else {
//							this.cancel();
//						}
//					}
//				}.runTaskTimer(PlayerWarps.get(), 0L, 20L);
//			}
			toggleBuild.put(player, true);
			building.put(player, true);
			prevent.put(player, true);
			String UUID = player.getUniqueId().toString();
			Utils.saveWarpBuilding(UUID);
			player.setScoreboard(initSB1.getScoreboard());
			if (notify) {
				Utils.sendMessage(player, "&eYou're now editing your playerwarp.");
				Utils.sendConsoleMessage("&6" + player.getName() + " &eis editing their playerwarp!");
			}
			PlayerWarps.get().reloadConfig();
		}
	}
	
//	public static void deleteVoidWorld(Player sender, OfflinePlayer player, boolean notify) {
//		String worldname = "PlayerWarps-World";
//		World mainworld = Bukkit.getWorld("world");
//		if (Bukkit.getWorld(worldname) != null) {
//			if (mainworld != null) {
//				for (Player players : Bukkit.getWorld(worldname).getPlayers()) {
//					players.teleport(mainworld.getSpawnLocation());
//					Utils.sendMessage(players, "&6" + player.getName() + "'s &eplayerwarp has been forcefully deleted.");
//				}
//				Bukkit.unloadWorld(worldname, false);
//				try {
//					FileUtils.deleteDirectory(new File(worldname));
//				} catch (IOException e) {
//					e.printStackTrace();
//				}
//				String UUID = player.getUniqueId().toString();
//				Utils.removeWarp(UUID);
//
//				if (notify) {
//					Utils.sendMessage(sender, "&eYou have forcefully deleted &6" + player.getName() + "'s &eplayerwarp.");
//				}
//			}
//		}
//		else {
//			if (notify) {
//				Utils.sendMessage(sender, "&6" + player.getName() + "'s &eplayerwarp either doesn't exist or is not loaded.");
//			}
//		}
//	}
	
	public static void approveVoidWorld(Player sender, OfflinePlayer player) {
		String worldname = "PlayerWarps-World";
		if (Bukkit.getWorld(worldname) != null) {
			World w = Bukkit.getWorld(worldname);
			Location loc;
			if (Utils.getPlayerWarpLocation(player.getUniqueId().toString()) != null) {
				loc = Utils.getPlayerWarpLocation(player.getUniqueId().toString());
				sender.teleport(loc);
			}
			ready.put(player, true);
			Utils.sendMessage(sender, "&6" + player.getName() + " &eneeds their playerwarp approved.");
			Utils.sendMessage(sender, "&f/&ewarpcreate approve &6" + player.getName() + "&e.");
			Utils.sendMessage(sender, "&eOnce their playerwarp has been checked for blacklisted items and has passed. You can do &f/&ewarpcreate approveconfirm &6" + player.getName() + "&e.");
			PlayerWarps.get().reloadConfig();
		}
	}
	
	public static void approveConfirmVoidWorld(OfflinePlayer player, boolean notify) {
		String worldname = "PlayerWarps-World";
		if (Bukkit.getWorld(worldname) != null) {
			World w = Bukkit.getWorld(worldname);
			Location loc;
			if (Utils.getPlayerWarpLocation(player.getUniqueId().toString()) != null) {
				loc = Utils.getPlayerWarpLocation(player.getUniqueId().toString());
				String UUIDD = player.getUniqueId().toString();
				if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null || Bukkit.getWorld("PlayerWarps-World") != null) {
					Utils.saveWarp(UUIDD, loc);
					BukkitScheduler scheduler = PlayerWarps.get().getServer().getScheduler();
					scheduler.scheduleSyncRepeatingTask(PlayerWarps.get(), new Runnable() {
						@Override
						public void run() {
							PlayerWarps.get().warpsort.clear();
			            	Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
			                for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
			        			UUID uuid = UUID.fromString(it.next());
			        			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString()) != null) {
			        				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
												if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") == null) {
													continue;
												}
												else {
													int sort = 0;
													Location loc = Utils.getPlayerWarpLocation(Bukkit.getOfflinePlayer(uuid).getUniqueId().toString());
													for (Player players : Bukkit.getWorld("PlayerWarps-World").getPlayers()) {
														if (Zone.contains(players.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
															sort++;
														}
													}
													PlayerWarps.get().warpsort.add(sort + " - " + uuid.toString());
												}
											}
										}
									}
			        			}
			        		}
			                Collections.sort(PlayerWarps.get().warpsort, Collections.reverseOrder());
			        		if (PlayerWarps.get().getCustomData().getStringList("WarpList") == null) {
			        			PlayerWarps.get().getCustomData().set("WarpSort", PlayerWarps.get().warpsort);
			        			PlayerWarps.get().saveConfig();
			        			PlayerWarps.get().reloadConfig();
			        		}
			        		else {
			        			PlayerWarps.get().getCustomData().set("WarpSort", null);
			        			PlayerWarps.get().getCustomData().set("WarpSort", PlayerWarps.get().warpsort);
			        			PlayerWarps.get().saveConfig();
			        			PlayerWarps.get().reloadConfig();
			        		}
						}
			        }, 20l, (long)(20 * PlayerWarps.get().getCustomData().getLong("guiRefreshRateInSeconds")));
				}
				else {
					Utils.saveWarp(UUIDD, loc);
				}
				if (notify) {
					for (Player players : Bukkit.getOnlinePlayers()) {
						Utils.sendMessage(players, "&6/PW " + player.getName() + " &eIS NOW &6OPEN&e.");
						Utils.sendMessage(players, "&6/PW " + player.getName() + " &eIS NOW &6OPEN&e.");
						Utils.sendMessage(players, "&6/PW " + player.getName() + " &eIS NOW &6OPEN&e.");
					}
				}
				PlayerWarps.get().reloadConfig();
			}
		}
	}
	
	public static void createWarp(Player player) {
		String worldname = "PlayerWarps-World";
		if (Bukkit.getWorld(worldname) == null) {
			WorldCreator wc = new WorldCreator(worldname);

			wc.type(WorldType.FLAT);
			wc.generatorSettings("2;0;1;");
	
			wc.createWorld();
			World w = Bukkit.getWorld(worldname);
			w.setGameRuleValue("doMobSpawning", "false");
			w.setGameRuleValue("randomTickSpeed", "0");
			Bukkit.dispatchCommand(Bukkit.getConsoleSender(), "mv import \"" + worldname + "\" normal");
			if (Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world")) != null) Bukkit.dispatchCommand(Bukkit.getConsoleSender(), "mvm set respawnWorld " + PlayerWarps.get().getCustomData().getString("Main-world") + " \"" + worldname + "\"");
			Location loc = new Location(w, PlayerWarps.get().nextLocation.getX() + 5000, 0, 0);
			PlayerWarps.getWarpBox().generateCube(loc, new int[]{49, 58, 49}, new int[]{9, 8, 7}, new int[]{7, 6, 0}, new int[]{47, 11, 47}, new int[]{7, 1, 6}, Material.GLASS, Material.GLOWSTONE, Material.AIR, Material.GRASS, Material.STONE, Material.BEACON);
			ItemStack block = new ItemStack(Material.GLASS);
			Utils.saveWallData(player.getUniqueId().toString(), block, true);
			Utils.saveWallData(player.getUniqueId().toString(), block, false);
			Location loc3 = loc.clone().add(24.500, 15.00000, -2.500);
			
			PlayerWarps.get().nextLocation.setX(PlayerWarps.get().nextLocation.getX()+5000);
			PlayerWarps.get().getCustomData().set("nextXLocation", PlayerWarps.get().nextLocation.getX());
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
			Utils.saveWarpCoordsBefore(player.getUniqueId().toString(), loc3);
			Utils.removeWarpBuilding(player.getUniqueId().toString());
		}
		else {
			if (Utils.getPlayerWarpLocation(player.getUniqueId().toString()) == null) {
				World w = Bukkit.getWorld(worldname);
				w.setGameRuleValue("randomTickSpeed", "0");
				Location loc = new Location(w, PlayerWarps.get().nextLocation.getX() + 5000, 0, 0);
				PlayerWarps.getWarpBox().generateCube(loc, new int[]{49, 58, 49}, new int[]{9, 8, 7}, new int[]{7, 6, 0}, new int[]{47, 11, 47}, new int[]{7, 1, 6}, Material.GLASS, Material.GLOWSTONE, Material.AIR, Material.GRASS, Material.STONE, Material.BEACON);
				ItemStack block = new ItemStack(Material.GLASS);
				Utils.saveWallData(player.getUniqueId().toString(), block, true);
				Utils.saveWallData(player.getUniqueId().toString(), block, false);
				Location loc3 = loc.clone().add(24.500, 15.00000, -2.500);
				PlayerWarps.get().nextLocation.setX(PlayerWarps.get().nextLocation.getX()+5000);
				PlayerWarps.get().getCustomData().set("nextXLocation", PlayerWarps.get().nextLocation.getX());
				PlayerWarps.get().saveConfig();
				PlayerWarps.get().reloadConfig();
				Utils.saveWarpCoordsBefore(player.getUniqueId().toString(), loc3);
				Utils.removeWarpBuilding(player.getUniqueId().toString());
			}
		}
	}
	
	public static void endSb(Player player) {
		player.setGameMode(GameMode.SURVIVAL);
		player.setGameMode(GameMode.SURVIVAL);
		player.setGameMode(GameMode.SURVIVAL);
		player.setGameMode(GameMode.SURVIVAL);
		player.getInventory().clear();
		toggleBuild.put(player, false);
		building.remove(player);
		Utils.removeWarpBuilding(player.getUniqueId().toString());
		PlayerWarps.get().reloadConfig();
		player.setScoreboard(Bukkit.getScoreboardManager().getMainScoreboard());
		if (PlayerWarps.get().getFeatherboardSupport()) {
			Bukkit.dispatchCommand(Bukkit.getConsoleSender(), "fb on " + player.getName());
		}
		PlayerWarps.get().reloadConfig();
	}
}
