package str.playerwarps.setup;

import java.util.concurrent.ThreadLocalRandom;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;

import com.boydti.fawe.util.EditSessionBuilder;
import com.sk89q.worldedit.EditSession;
import com.sk89q.worldedit.MaxChangedBlocksException;
import com.sk89q.worldedit.Vector;
import com.sk89q.worldedit.blocks.BaseBlock;

import str.playerwarps.*;
import str.playerwarps.util.Utils;

public class WarpBox implements Listener {
	
	public void generateCube(Location startPos, int[] dimensions, int[] dimensions2, int[] dimensions3, int[] dimensions4, int[] dimensions5, Material cubeMat, Material spawn, Material drop, Material floor, Material spawn2, Material CP) {
		// startPos is the first block of the cube
		// the cube will be generated in x+, y+, z+ direction
		// dimensions need to contain the width, height, length (e.g. {3, 3, 3} -> 3x3x3 Cube)
		if (dimensions.length == 3) {
			for (int x = 0; x < dimensions[0]; x++) {
				for (int y = 0; y < dimensions[1]; y++) {
					for (int z = 0; z <= dimensions[2]; z++) {
						Block b = startPos.getBlock().getRelative(x, y, z);
						if (x == 0 || y == 0 || z == 0 || x == dimensions[0] - 1 || y == dimensions[1] - 1 || z == dimensions[2]) {
							b.setType(cubeMat);
						}
					}
				}
			}
		}
//		if (dimensions5.length == 3) {
//			Location loc3 = startPos.clone().add(21, 14, -6);
//			for (int x = 0; x < dimensions5[0]; x++) {
//				for (int y = 0; y < dimensions5[1]; y++) {
//					for (int z = 0; z <= dimensions5[2]; z++) {
//						Block b = loc3.clone().getBlock().getRelative(x, y, z);
//						b.setType(spawn2);
//					}
//				}
//			}
//		}
		if (dimensions2.length == 3) {
			Location loc = startPos.clone().add(20, 13, -7);
			for (int x = 0; x < dimensions2[0]; x++) {
				for (int y = 0; y < dimensions2[1]; y++) {
					for (int z = 0; z <= dimensions2[2]; z++) {
						Block b = loc.clone().getBlock().getRelative(x, y, z);
						if (x == 0 || y == 0 || z == 0 || x == dimensions2[0] - 1 || y == dimensions2[1] - 1 || z == dimensions2[2]) {
							b.setType(cubeMat);
						}
					}
				}
			}
		}
		if (dimensions3.length == 3) {
			Location loc3 = startPos.clone().add(21, 14, 0);
			for (int x = 0; x < dimensions3[0]; x++) {
				for (int y = 0; y < dimensions3[1]; y++) {
					for (int z = 0; z <= dimensions3[2]; z++) {
						Block b = loc3.clone().getBlock().getRelative(x, y, z);
						if (x == 0 || y == 0 || z == 0 || x == dimensions3[0] - 1 || y == dimensions3[1] - 1 || z == dimensions3[2]) {
							b.setType(drop);
						}
					}
				}
			}
			if (dimensions5.length == 3) {
				Location loc4 = startPos.clone().add(21, 14, -6);
				for (int x = 0; x < dimensions5[0]; x++) {
					for (int y = 0; y < dimensions5[1]; y++) {
						for (int z = 0; z <= dimensions5[2]; z++) {
							Block b = loc4.clone().getBlock().getRelative(x, y, z);
							b.setType(spawn2);
						}
					}
				}
				Location loc2 = startPos.clone().add(24, 14, -3);
				Block bb = loc2.clone().getBlock();
				bb.setType(spawn);
			}
		}
		if (dimensions4.length == 3) {
			Location loc3 = startPos.clone().add(1, 1, 1);
			for (int x = 0; x < dimensions4[0]; x++) {
				for (int y = 0; y < dimensions4[1]; y++) {
					for (int z = 0; z <= dimensions4[2]; z++) {
						Block b = loc3.clone().getBlock().getRelative(x, y, z);
						b.setType(floor);
					}
				}
			}
		}
		Location loc3 = startPos.clone().add(24, 15, -2).add(0, 1, -5);
		Block b = loc3.clone().getBlock();
		b.setType(CP);
	}
	
	public String testForWarpWalls(Player player, Block b) {
		
		Location loc1 = Utils.getPlayerWarpLocation(player.getUniqueId().toString()).subtract(24.500, 15.00000, -2.500);
		Location loc2 = loc1.clone().add(49, 58, 49);
		int xLow = Math.min(loc1.getBlockX(), loc2.getBlockX());
		int xHigh = Math.max(loc1.getBlockX(), loc2.getBlockX());
		
		int yLow = Math.min(loc1.getBlockY(), loc2.getBlockY());
		int yHigh = Math.max(loc1.getBlockY(), loc2.getBlockY());
		
		int zLow = Math.min(loc1.getBlockZ(), loc2.getBlockZ());
		int zHigh = Math.max(loc1.getBlockZ(), loc2.getBlockZ());
		
		
		Location loc3 = loc1.clone().add(20, 13, -7);
		Location loc4 = loc3.clone().add(9, 8, 7);
		int xLow1 = Math.min(loc3.getBlockX(), loc4.getBlockX());
		int xHigh1 = Math.max(loc3.getBlockX(), loc4.getBlockX());
		
		int yLow1 = Math.min(loc3.getBlockY(), loc4.getBlockY());
		int yHigh1 = Math.max(loc3.getBlockY(), loc4.getBlockY());
		
		int zLow1 = Math.min(loc3.getBlockZ(), loc4.getBlockZ());
		int zHigh1 = Math.max(loc3.getBlockZ(), loc4.getBlockZ());
		
		
		
		for (int x = xLow; x <= xHigh; x++) {
			for (int y = yLow; y <= yHigh; y++) {
				for (int z = zLow; z <= zHigh; z++) {
					if (x == xLow || y == yLow || z == zLow || x == xHigh - 1 || y == yHigh - 1 || z == zHigh) {
						if (b.getX() == x && b.getY() == y && b.getZ() == z) {
							return "Disallow";
						}
					}
				}
			}
		}
		
		for (int x = xLow1; x <= xHigh1; x++) {
			for (int y = yLow1; y <= yHigh1; y++) {
				for (int z = zLow1; z <= zHigh1; z++) {
					if (b.getX() == x && b.getY() == y && b.getZ() == z) {
						if (b.getType() == Material.BEACON) return "Allow";
						return "SafeZone";
					}
//					if (x == zLow1 || y == zLow1 || z == zLow1 || x == xHigh1 - 1 || y == yHigh1 - 1 || z == zHigh1) {
//					}
				}
			}
		}
		return "Allow";
	}
	
	public void generateCubee(Location startPos, int[] dimensions, int[] dimensions2, int[] dimensions3, int[] dimensions4, int[] dimensions5, ItemStack[] cubeMat, Material spawn, Material drop, Material floor, Material spawn2, Material CP) {
		// startPos is the first block of the cube
		// the cube will be generated in x+, y+, z+ direction
		// dimensions need to contain the width, height, length (e.g. {3, 3, 3} -> 3x3x3 Cube)
		EditSession editSession = new EditSessionBuilder(startPos.getWorld().getName()).fastmode(true).limitUnlimited().build();
		if (dimensions.length == 3) {
			for (int x = 0; x < dimensions[0]; x++) {
				for (int y = 0; y < dimensions[1]; y++) {
					for (int z = 0; z <= dimensions[2]; z++) {
						Block b = startPos.getBlock().getRelative(x, y, z);
						if (b.getType() != Material.BEACON) {
							if (x == 0 || y == 0 || z == 0 || x == dimensions[0] - 1 || y == dimensions[1] - 1 || z == dimensions[2]) {
								if (cubeMat.length == 1) {
									int random = 0;
									try {
										editSession.setBlock(new Vector(b.getX(), b.getY(), b.getZ()), new BaseBlock(cubeMat[random].getTypeId(), cubeMat[random].getData().getData()));
									} catch (MaxChangedBlocksException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
								else {
									int random = ThreadLocalRandom.current().nextInt(0, cubeMat.length);
									try {
										editSession.setBlock(new Vector(b.getX(), b.getY(), b.getZ()), new BaseBlock(cubeMat[random].getTypeId(), cubeMat[random].getData().getData()));
									} catch (MaxChangedBlocksException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
							editSession.flushQueue();
						}
					}
				}
			}
		}
//		if (dimensions5.length == 3) {
//			Location loc3 = startPos.clone().add(21, 14, -6);
//			for (int x = 0; x < dimensions5[0]; x++) {
//				for (int y = 0; y < dimensions5[1]; y++) {
//					for (int z = 0; z <= dimensions5[2]; z++) {
//						Block b = loc3.clone().getBlock().getRelative(x, y, z);
//						b.setType(spawn2);
//					}
//				}
//			}
//		}
		if (dimensions2.length == 3) {
			Location loc = startPos.clone().add(20, 13, -7);
			for (int x = 0; x < dimensions2[0]; x++) {
				for (int y = 0; y < dimensions2[1]; y++) {
					for (int z = 0; z <= dimensions2[2]; z++) {
						Block b = loc.clone().getBlock().getRelative(x, y, z);
						if (b.getType() != Material.BEACON) {
							if (x == 0 || y == 0 || z == 0 || x == dimensions2[0] - 1 || y == dimensions2[1] - 1 || z == dimensions2[2]) {
								if (cubeMat.length == 1) {
									int random = 0;
									try {
										editSession.setBlock(new Vector(b.getX(), b.getY(), b.getZ()), new BaseBlock(cubeMat[random].getTypeId(), cubeMat[random].getData().getData()));
									} catch (MaxChangedBlocksException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
								else {
									int random = ThreadLocalRandom.current().nextInt(0, cubeMat.length);
									try {
										editSession.setBlock(new Vector(b.getX(), b.getY(), b.getZ()), new BaseBlock(cubeMat[random].getTypeId(), cubeMat[random].getData().getData()));
									} catch (MaxChangedBlocksException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
							editSession.flushQueue();
						}
					}
				}
			}
		}
		if (dimensions3.length == 3) {
			Location loc3 = startPos.clone().add(21, 14, 0);
			for (int x = 0; x < dimensions3[0]; x++) {
				for (int y = 0; y < dimensions3[1]; y++) {
					for (int z = 0; z <= dimensions3[2]; z++) {
						Block b = loc3.clone().getBlock().getRelative(x, y, z);
						if (b.getType() != Material.BEACON) {
							if (x == 0 || y == 0 || z == 0 || x == dimensions3[0] - 1 || y == dimensions3[1] - 1 || z == dimensions3[2]) {
								try {
									editSession.setBlock(new Vector(b.getX(), b.getY(), b.getZ()), new BaseBlock(drop.getId()));
								} catch (MaxChangedBlocksException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							}
							editSession.flushQueue();
						}
					}
				}
			}
			if (dimensions5.length == 3) {
				Location loc4 = startPos.clone().add(21, 14, -6);
				for (int x = 0; x < dimensions5[0]; x++) {
					for (int y = 0; y < dimensions5[1]; y++) {
						for (int z = 0; z <= dimensions5[2]; z++) {
							Block b = loc4.clone().getBlock().getRelative(x, y, z);
							if (b.getType() != Material.BEACON) {
								try {
									editSession.setBlock(new Vector(b.getX(), b.getY(), b.getZ()), new BaseBlock(spawn2.getId()));
								} catch (MaxChangedBlocksException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							}
						}
					}
				}
			}
		}
		if (dimensions4.length == 3) {
			Location loc3 = startPos.clone().add(1, 1, 1);
			for (int x = 0; x < dimensions4[0]; x++) {
				for (int y = 0; y < dimensions4[1]; y++) {
					for (int z = 0; z <= dimensions4[2]; z++) {
						Block b = loc3.clone().getBlock().getRelative(x, y, z);
						try {
							editSession.setBlock(new Vector(b.getX(), b.getY(), b.getZ()), new BaseBlock(spawn2.getId()));
						} catch (MaxChangedBlocksException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						editSession.flushQueue();
					}
				}
			}
		}
		Location loc3 = startPos.clone().add(24, 15, -2).add(0, 1, -5);
		Block b = loc3.clone().getBlock();
		try {
			editSession.setBlock(new Vector(b.getX(), b.getY(), b.getZ()), new BaseBlock(CP.getId()));
		} catch (MaxChangedBlocksException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Location loc2 = startPos.clone().add(24, 14, -3);
		Block bb = loc2.clone().getBlock();
		try {
			editSession.setBlock(new Vector(bb.getX(), bb.getY(), bb.getZ()), new BaseBlock((spawn.getId())));
		} catch (MaxChangedBlocksException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		editSession.flushQueue();
	}
	
	public void generateCube1(Location startPos, int[] dimensions, int[] dimensions2, int[] dimensions3, int[] dimensions4, int[] dimensions5, Material cubeMat, Material spawn, Material drop, Material floor, Material spawn2) {
		// startPos is the first block of the cube
		// the cube will be generated in x+, y+, z+ direction
		// dimensions need to contain the width, height, length (e.g. {3, 3, 3} -> 3x3x3 Cube)
		if (dimensions.length == 3) {
			for (int x = 0; x < dimensions[0]; x++) {
				for (int y = 0; y < dimensions[1]; y++) {
					for (int z = 0; z <= dimensions[2]; z++) {
						Block b = startPos.getBlock().getRelative(x, y, z);
						if (x == 0 || y == 0 || z == 0 || x == dimensions[0] - 1 || y == dimensions[1] - 1 || z == dimensions[2]) {
							b.setType(cubeMat);
						}
					}
				}
			}
		}
//		if (dimensions5.length == 3) {
//			Location loc3 = startPos.clone().add(21, 14, -6);
//			for (int x = 0; x < dimensions5[0]; x++) {
//				for (int y = 0; y < dimensions5[1]; y++) {
//					for (int z = 0; z <= dimensions5[2]; z++) {
//						Block b = loc3.clone().getBlock().getRelative(x, y, z);
//						b.setType(spawn2);
//					}
//				}
//			}
//		}
		if (dimensions2.length == 3) {
			Location loc = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(20, 13, -7);
			for (int x = 0; x < dimensions2[0]; x++) {
				for (int y = 0; y < dimensions2[1]; y++) {
					for (int z = 0; z <= dimensions2[2]; z++) {
						Block b = loc.clone().getBlock().getRelative(x, y, z);
						if (x == 0 || y == 0 || z == 0 || x == dimensions2[0] - 1 || y == dimensions2[1] - 1 || z == dimensions2[2]) {
							b.setType(cubeMat);
						}
					}
				}
			}
		}
		if (dimensions3.length == 3) {
			Location loc3 = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(21, 14, 0);
			for (int x = 0; x < dimensions3[0]; x++) {
				for (int y = 0; y < dimensions3[1]; y++) {
					for (int z = 0; z <= dimensions3[2]; z++) {
						Block b = loc3.clone().getBlock().getRelative(x, y, z);
						if (x == 0 || y == 0 || z == 0 || x == dimensions3[0] - 1 || y == dimensions3[1] - 1 || z == dimensions3[2]) {
							b.setType(drop);
						}
					}
				}
			}
			if (dimensions5.length == 3) {
				Location loc4 = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(21, 14, -6);
				for (int x = 0; x < dimensions5[0]; x++) {
					for (int y = 0; y < dimensions5[1]; y++) {
						for (int z = 0; z <= dimensions5[2]; z++) {
							Block b = loc4.clone().getBlock().getRelative(x, y, z);
							b.setType(spawn2);
						}
					}
				}
				Location loc2 = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(24, 14, -3);
				Block bb = loc2.clone().getBlock();
				bb.setType(spawn);
			}
		}
		if (dimensions4.length == 3) {
			Location loc3 = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(-19, 1, 1);
			for (int x = 0; x < dimensions4[0]; x++) {
				for (int y = 0; y < dimensions4[1]; y++) {
					for (int z = 0; z <= dimensions4[2]; z++) {
						Block b = loc3.clone().getBlock().getRelative(x, y, z);
						b.setType(floor);
					}
				}
			}
		}
	}
	
	public void generateCube2(Location startPos, int[] dimensions, int[] dimensions2, int[] dimensions3, int[] dimensions4, int[] dimensions5, Material cubeMat, Material spawn, Material drop, Material floor, Material spawn2) {
		// startPos is the first block of the cube
		// the cube will be generated in x+, y+, z+ direction
		// dimensions need to contain the width, height, length (e.g. {3, 3, 3} -> 3x3x3 Cube)
		if (dimensions.length == 3) {
			for (int x = 0; x < dimensions[0]; x++) {
				for (int y = 0; y < dimensions[1]; y++) {
					for (int z = 0; z <= dimensions[2]; z++) {
						Block b = startPos.getBlock().getRelative(x, y, z);
						if (x == 0 || y == 0 || z == 0 || x == dimensions[0] - 1 || y == dimensions[1] - 1 || z == dimensions[2]) {
							b.setType(cubeMat);
						}
					}
				}
			}
		}
//		if (dimensions5.length == 3) {
//			Location loc3 = startPos.clone().add(21, 14, -6);
//			for (int x = 0; x < dimensions5[0]; x++) {
//				for (int y = 0; y < dimensions5[1]; y++) {
//					for (int z = 0; z <= dimensions5[2]; z++) {
//						Block b = loc3.clone().getBlock().getRelative(x, y, z);
//						b.setType(spawn2);
//					}
//				}
//			}
//		}
		if (dimensions2.length == 3) {
			Location loc = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(20, 13, -7);
			for (int x = 0; x < dimensions2[0]; x++) {
				for (int y = 0; y < dimensions2[1]; y++) {
					for (int z = 0; z <= dimensions2[2]; z++) {
						Block b = loc.clone().getBlock().getRelative(x, y, z);
						if (x == 0 || y == 0 || z == 0 || x == dimensions2[0] - 1 || y == dimensions2[1] - 1 || z == dimensions2[2]) {
							b.setType(cubeMat);
						}
					}
				}
			}
		}
		if (dimensions3.length == 3) {
			Location loc3 = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(21, 14, 0);
			for (int x = 0; x < dimensions3[0]; x++) {
				for (int y = 0; y < dimensions3[1]; y++) {
					for (int z = 0; z <= dimensions3[2]; z++) {
						Block b = loc3.clone().getBlock().getRelative(x, y, z);
						if (x == 0 || y == 0 || z == 0 || x == dimensions3[0] - 1 || y == dimensions3[1] - 1 || z == dimensions3[2]) {
							b.setType(drop);
						}
					}
				}
			}
			if (dimensions5.length == 3) {
				Location loc4 = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(21, 14, -6);
				for (int x = 0; x < dimensions5[0]; x++) {
					for (int y = 0; y < dimensions5[1]; y++) {
						for (int z = 0; z <= dimensions5[2]; z++) {
							Block b = loc4.clone().getBlock().getRelative(x, y, z);
							b.setType(spawn2);
						}
					}
				}
				Location loc2 = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(24, 14, -3);
				Block bb = loc2.clone().getBlock();
				bb.setType(spawn);
			}
		}
		if (dimensions4.length == 3) {
			Location loc3 = startPos.clone().getWorld().getBlockAt(0, 0, 0).getLocation().add(-19, 1, 1);
			for (int x = 0; x < dimensions4[0]; x++) {
				for (int y = 0; y < dimensions4[1]; y++) {
					for (int z = 0; z <= dimensions4[2]; z++) {
						Block b = loc3.clone().getBlock().getRelative(x, y, z);
						b.setType(floor);
					}
				}
			}
		}
	}
	
	public boolean checkPos(Location startPos, int[] dimensions) {
		if (dimensions.length == 3) {
			Location loc = startPos.clone().add(23, 3, -8);
			for (int x = 0; x < dimensions[0]; x++) {
				for (int y = 0; y < dimensions[1]; y++) {
					for (int z = 0; z <= dimensions[2]; z++) {
						if (x == 0 || y == 0 || z == 0 || x == dimensions[0] - 1 || y == dimensions[1] - 1 || z == dimensions[2]) {
							return true;
						}
					}
				}
			}
		}
		return false;
	}
}

