package str.playerwarps.util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import net.md_5.bungee.api.ChatColor;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.ComponentBuilder;
import net.md_5.bungee.api.chat.HoverEvent;
import net.md_5.bungee.api.chat.TextComponent;
import str.playerwarps.PlayerWarps;

public class Utils {
	
	public static String formatSeconds(long seconds)
	{
		long days = seconds / (24 * 60 * 60);
		seconds %= 24 * 60 * 60;
		long hh = seconds / (60 * 60);
		seconds %= 60 * 60;
		long mm = seconds / 60;
		seconds %= 60;
		long ss = seconds;

		if (days > 0)
		{
			return days + "d" + hh + "h" + mm + "m" + ss + "s";
		}
		if (hh > 0)
		{
			return hh + "h" + mm + "m" + ss + "s";
		}
		if (mm > 0)
		{
			return mm + "m" + ss + "s";
		}
		return ss + "s";
	}
	
	public static String replace(String text) {
		return ChatColor.translateAlternateColorCodes('&', text);
	}
	
	public static void sendMessage(CommandSender sender, String message) {
		sender.sendMessage(replace(message));
	}
	
	public static void bMsg(String message) {
		for (Player p : Bukkit.getOnlinePlayers()) { sendMessage(p, message); }
	}
	
	public static void sendConsoleMessage(String message) {
		PlayerWarps.get().getServer().getConsoleSender().sendMessage(replace(message));
	}
	
	public static void saveUsedWarpCreate(String str) {
		PlayerWarps.get().getCustomData().set("Used-Warp-Blocks." + str, true);
		PlayerWarps.get().saveConfig();
		PlayerWarps.get().reloadConfig();
	}
	
	public static boolean getUsedWarpCreate(String str) {
		boolean duped = false;
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Used-Warp-Blocks") != null) {
			if (PlayerWarps.get().getCustomData().get("Used-Warp-Blocks." + str) != null) {
				if (PlayerWarps.get().getCustomData().getString("Used-Warp-Blocks." + str).equalsIgnoreCase("true")) {
					duped = true;
				}
			}
		}
		return duped;
	}
	
	public static void saveWarpCoordsBefore(String playeruuid, Location loc) {
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".xb", loc.getX());
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".yb", loc.getY());
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".zb", loc.getZ());
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".worldnameB", loc.getWorld().getName());
		PlayerWarps.get().saveConfig();
		PlayerWarps.get().reloadConfig();
	}
	
	public static int getEditTime(String playeruuid) {
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warp-Edit-Time") != null) {
			if (PlayerWarps.get().getCustomData().get("Warp-Edit-Time." + playeruuid) != null) {
				return PlayerWarps.get().getCustomData().getInt("Warp-Edit-Time." + playeruuid);
			}
		}
		return 0;
	}
	
	public static boolean getTransactions(String playeruuid) {
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warp-Edit-Transactions") != null) {
			if (PlayerWarps.get().getCustomData().get("Warp-Edit-Transactions." + playeruuid) != null) {
				return true;
			}
		}
		return false;
	}
	
	public static void deleteWarpTransactions(String playeruuid) {
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warp-Edit-Transactions") != null) {
			if (PlayerWarps.get().getCustomData().get("Warp-Edit-Transactions." + playeruuid) != null) {
				PlayerWarps.get().getCustomData().set("Warp-Edit-Transactions." + playeruuid, null);
			}
		}
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warp-Edit-Time") != null) {
			if (PlayerWarps.get().getCustomData().get("Warp-Edit-Time." + playeruuid) != null) {
				PlayerWarps.get().getCustomData().set("Warp-Edit-Time." + playeruuid, null);
			}
		}
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid, null);
		PlayerWarps.get().saveConfig();
		PlayerWarps.get().reloadConfig();
	}
	
	public static void saveEditTime(String playeruuid, int time, String transaction, String adding) {
		List<String> transactions = new ArrayList<String>();
		if (PlayerWarps.get().getCustomData().get("Warp-Edit-Transactions." + playeruuid) == null) {
			transactions.add((adding.equalsIgnoreCase("true") ? "&a" : "&c") + transaction);
			PlayerWarps.get().getCustomData().set("Warp-Edit-Transactions." + playeruuid, transactions);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
		}
		else if (PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + playeruuid).size() < 10) {
			int count = 1;
			List<String> t = (List<String>) PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + playeruuid);
//			if (t.size() == 1) {
//				t.get(0).replace("&e&l1", "&e&l2");
//			}
			transactions.add((adding.equalsIgnoreCase("true") ? "&a" : "&c") + transaction);
			for (int i = 0; i < t.size(); i++) {
				transactions.add(t.get(i));
			}
			PlayerWarps.get().getCustomData().set("Warp-Edit-Transactions." + playeruuid, transactions);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
		}
		else if (PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + playeruuid).size() == 10) {
			int count = 1;
			List<String> t = (List<String>) PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + playeruuid);
			t.remove(9);
			PlayerWarps.get().getCustomData().set("Warp-Edit-Transactions", t);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
			transactions.add((adding.equalsIgnoreCase("true") ? "&a" : "&c") + transaction);
			for (int i = 0; i < t.size(); i++) {
				transactions.add(t.get(i));
			}
			PlayerWarps.get().getCustomData().set("Warp-Edit-Transactions." + playeruuid, transactions);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
		}
		if (PlayerWarps.get().getCustomData().get("Warp-Edit-Time." + playeruuid) == null) {
			PlayerWarps.get().getCustomData().set("Warp-Edit-Time." + playeruuid, time);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
			return;
		}
		else {
			if (adding.equalsIgnoreCase("true")) {
				time = PlayerWarps.get().getCustomData().getInt("Warp-Edit-Time." + playeruuid) + time;
			}
			PlayerWarps.get().getCustomData().set("Warp-Edit-Time." + playeruuid, time);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
			return;
		}
	}
	
	
	public static void saveWarpBuilding(String playeruuid) {
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Building", true);
		PlayerWarps.get().saveConfig();
		PlayerWarps.get().reloadConfig();
	}
	
	public static void removeWarpBuilding(String playeruuid) {
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Building", false);
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Approved", false);
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Need-Approval", true);
		PlayerWarps.get().saveConfig();
		PlayerWarps.get().reloadConfig();
	}
	
	
	public static void saveWarp(String playeruuid, Location loc) {
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".x", loc.getX());
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".y", loc.getY());
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".z", loc.getZ());
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".worldname", loc.getWorld().getName());
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Need-Approval", false);
		PlayerWarps.get().saveConfig();
		PlayerWarps.get().reloadConfig();
	}
	
	public static void removeWarp(String playeruuid) {
		if (PlayerWarps.get().getCustomData().contains("Warps-Created-By." + playeruuid)) {
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid, null);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
		}
	}
	
	public static ItemStack getWallData(String playeruuid, boolean first) {
		if (!PlayerWarps.get().getCustomData().contains("Warps-Created-By." + playeruuid)) return null;
		if (first) {
			ItemStack compare = PlayerWarps.get().getCustomData().getItemStack("Warps-Created-By." + playeruuid + ".roomWallItem");
			return compare;
		}
		else {
			ItemStack compare = PlayerWarps.get().getCustomData().getItemStack("Warps-Created-By." + playeruuid + ".warpWallItem");
			return compare;
		}
	}
	
	public static void saveWallData(String playeruuid, ItemStack block, boolean first) {
		if (first) {
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".roomWallItem", block);
		}
		else {
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".warpWallItem", block);
		}
		PlayerWarps.get().saveConfig();
		PlayerWarps.get().reloadConfig();
	}
	
	public static void fixWarp(String playeruuid) {
		if (PlayerWarps.get().getCustomData().contains("Warps-Created-By." + playeruuid)) {
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".x", null);
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".y", null);
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".z", null);
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".worldname", null);
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Building", null);
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Approved", null);
			PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Need-Approval", null);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
		}
	}
	
	public static void saveEditingWarp(String playeruuid) {
		if (!PlayerWarps.get().getCustomData().contains("Warps-Created-By." + playeruuid)) return;
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".x", null);
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".y", null);
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".z", null);
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".worldname", null);
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Building", null);
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Approved", null);
		PlayerWarps.get().getCustomData().set("Warps-Created-By." + playeruuid + ".Need-Approval", null);
		PlayerWarps.get().saveConfig();
		PlayerWarps.get().reloadConfig();
	}
	
	public static void teleportToWarp(Player player, String playeruuid) {
		if (PlayerWarps.get().getCustomData().contains("Warps-Created-By." + playeruuid)) {
			double x = PlayerWarps.get().getCustomData().getDouble("Warps-Created-By." + playeruuid + ".x");
			double y = PlayerWarps.get().getCustomData().getDouble("Warps-Created-By." + playeruuid + ".y");
			double z = PlayerWarps.get().getCustomData().getDouble("Warps-Created-By." + playeruuid + ".z");
			String worldname = PlayerWarps.get().getCustomData().getString("Warps-Created-By." + playeruuid + ".worldname");
			Location loc = new Location(Bukkit.getWorld(worldname), x, y, z);
			player.teleport(loc);
			if (Bukkit.getPlayer(UUID.fromString(playeruuid)) != null) {
				Utils.sendMessage(player, "&eTeleporting to &6" + Bukkit.getPlayer(UUID.fromString(playeruuid)).getName() + "'s &eplayerwarp.");
			}
			else {
				Utils.sendMessage(player, "&eTeleporting to &6" + Bukkit.getOfflinePlayer(UUID.fromString(playeruuid)).getName() + "'s &eplayerwarp.");
			}
		}
	}
	
	public static Location getPlayerWarpLocation(String playeruuid) {
		if (!PlayerWarps.get().getCustomData().contains("Warps-Created-By." + playeruuid)) return null;
		double x = PlayerWarps.get().getCustomData().getDouble("Warps-Created-By." + playeruuid + ".xb");
		double y = PlayerWarps.get().getCustomData().getDouble("Warps-Created-By." + playeruuid + ".yb");
		double z = PlayerWarps.get().getCustomData().getDouble("Warps-Created-By." + playeruuid + ".zb");
		String worldname = PlayerWarps.get().getCustomData().getString("Warps-Created-By." + playeruuid + ".worldnameb");
		Location loc = new Location(Bukkit.getWorld("PlayerWarps-World"), x, y, z);
		return loc;
	}
	
	public static OfflinePlayer getOfflinePlayer(UUID uuid) {
	    OfflinePlayer offlinePlayer = Bukkit.getOfflinePlayer(uuid);
	    return offlinePlayer.hasPlayedBefore() ? offlinePlayer : null;
	}
	
	public static int getWarps() {
		int i = 0;
		Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
		for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
			UUID uuid = UUID.fromString(it.next());
			if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString()) != null) {
				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
					if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval").equalsIgnoreCase("false")) {
						if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") != null) {
							i += 1;
						}
					}
				}
			}
		}
		return i;
	}
	
	public static String replace1(String message) {
		return message.replaceAll("&", "\u00A7");
	}
	
	public static boolean isPlayerBuilding(Player playeruuid) {
		if (playeruuid.getWorld() == Bukkit.getWorld("PlayerWarp " + playeruuid.getUniqueId().toString())) {
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + playeruuid.getUniqueId().toString()) != null) {
				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + playeruuid.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
					return true;
				}
				return false;
			}
		}
		else {
			return false;
		}
		return false;
	}
	
	/**
	 * Sends the HELP as a paginated list of strings in chat to a player
	 *
	 * @param sender The sender to send the list to
	 * @param list The list to paginate
	 * @param page The page number to display.
	 */
	public static void paginate(CommandSender sender, ArrayList<String> list, int page) {
		int contentLinesPerPage = 5;
		int totalPageCount = 1;
		
		if((list.size() % contentLinesPerPage) == 0) {
			if(list.size() > 0)	{
				totalPageCount = list.size() / contentLinesPerPage;
			}    
		}
		else {
			totalPageCount = (list.size() / contentLinesPerPage) + 1;
		}
		if(page <= totalPageCount) {
			String paginatefirstline = "&ePage &3" + String.valueOf(page) +  "&f/&3" + String.valueOf(totalPageCount) + "&e.";
			
			Utils.sendMessage(sender, paginatefirstline);
			//beginline
	
			if(list.isEmpty()) {
				Utils.sendMessage(sender, "&cThere is nothing to show...");
			}
			else {
				int i = 0, k = 0;
				page--;
				
				Player player = (Player) sender;
	
				for (String entry : list) {
					k++;
					if ((((page * contentLinesPerPage) + i + 1) == k) && (k != ((page * contentLinesPerPage) + contentLinesPerPage + 1))) {
						i++;
						TextComponent msg = new TextComponent(Utils.replace(" - &3" + entry + " &f- &eClick to view and approve warp."));
						msg.setHoverEvent(new HoverEvent(HoverEvent.Action.SHOW_TEXT, new ComponentBuilder(Utils.replace("&eClick to view and approve warp.")).create()));
						msg.setClickEvent(new ClickEvent(ClickEvent.Action.RUN_COMMAND, "/warpcreate approve " + entry));
						player.spigot().sendMessage(msg);
					}
				}
			}
			//endline
		}
		else {
			Utils.sendMessage(sender, "&eThere are only &3" + totalPageCount + " &epage(s).");
		}
	}
	
	/**
	 * Sends the HELP as a paginated list of strings in chat to a player
	 *
	 * @param sender The sender to send the list to
	 * @param list The list to paginate
	 * @param page The page number to display.
	 */
	public static void paginate1(CommandSender sender, ArrayList<String> list, int page) {
		int contentLinesPerPage = 5;
		int totalPageCount = 1;
		
		if((list.size() % contentLinesPerPage) == 0) {
			if(list.size() > 0)	{
				totalPageCount = list.size() / contentLinesPerPage;
			}    
		}
		else {
			totalPageCount = (list.size() / contentLinesPerPage) + 1;
		}
		if(page <= totalPageCount) {
			String paginatefirstline = "&ePage &3" + String.valueOf(page) +  "&f/&3" + String.valueOf(totalPageCount) + "&e.";
			
			Utils.sendMessage(sender, paginatefirstline);
			//beginline
	
			if(list.isEmpty()) {
				Utils.sendMessage(sender, "&cThere is nothing to show...");
			}
			else {
				int i = 0, k = 0;
				page--;
				
				Player player = (Player) sender;
	
				for (String entry : list) {
					k++;
					if ((((page * contentLinesPerPage) + i + 1) == k) && (k != ((page * contentLinesPerPage) + contentLinesPerPage + 1))) {
						i++;
						TextComponent msg = new TextComponent(Utils.replace(" &e- &6" + entry));
						player.spigot().sendMessage(msg);
					}
				}
			}
			//endline
		}
		else {
			Utils.sendMessage(sender, "&eThere are only &3" + totalPageCount + " &epage(s).");
		}
	}
	
	public static void performCommand(Player player, String command) {
		TaskChain.newChain().add(new TaskChain.GenericTask() {
	        public void run() {
	            player.chat("/" + command);
	        }
	    }).execute();
	}
}
